/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern0 (x3, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 1;

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0)
        return -1;
      return 2;

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XVECLEN (x2, 0) != 2
      || XINT (x2, 1) != 19)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != IF_THEN_ELSE)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != PC)
    return -1;
  return 0;
}

int
pattern18 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V16QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 4;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode
          || !register_operand (operands[1], E_TImode))
        return -1;
      return 5;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 6;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 7;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x3) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 8;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x3) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern43 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 33
      || GET_MODE (x6) != E_CCmode)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[1] = x8;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x9 = XEXP (x4, 0);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[0]))
    return -1;
  return 0;
}

int
pattern51 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern57 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_mask_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[3], i1)
      || !contiguous_bitmask_nowrap_operand (operands[2], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_TDmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TDmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TFmode:
          return 0;

        case E_FPRX2mode:
          return 1;

        case E_DFmode:
          return 2;

        case E_SFmode:
          return 3;

        default:
          return -1;
        }

    case E_DDmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DDmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TFmode:
          return 4;

        case E_FPRX2mode:
          return 5;

        case E_DFmode:
          return 6;

        case E_SFmode:
          return 7;

        default:
          return -1;
        }

    case E_SDmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SDmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TFmode:
          return 8;

        case E_FPRX2mode:
          return 9;

        case E_DFmode:
          return 10;

        case E_SFmode:
          return 11;

        default:
          return -1;
        }

    case E_TFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_TFmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 12;

        case E_DDmode:
          return 13;

        case E_SDmode:
          return 14;

        default:
          return -1;
        }

    case E_FPRX2mode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_FPRX2mode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 15;

        case E_DDmode:
          return 16;

        case E_SDmode:
          return 17;

        default:
          return -1;
        }

    case E_DFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DFmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 18;

        case E_DDmode:
          return 19;

        case E_SDmode:
          return 20;

        default:
          return -1;
        }

    case E_SFmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SFmode)
        return -1;
      x4 = XEXP (x3, 0);
      switch (GET_MODE (x4))
        {
        case E_TDmode:
          return 21;

        case E_DDmode:
          return 22;

        case E_SDmode:
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern108 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern114 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (XVECLEN (x3, 0))
    {
    case 8:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 4);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x3, 0, 5);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XVECEXP (x3, 0, 6);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x12 = XVECEXP (x3, 0, 7);
      if (GET_CODE (x12) != CONST_INT
          || !register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0LL:
          if (XWINT (x6, 0) != 1LL
              || XWINT (x7, 0) != 2LL
              || XWINT (x8, 0) != 3LL
              || XWINT (x9, 0) != 4LL
              || XWINT (x10, 0) != 5LL
              || XWINT (x11, 0) != 6LL
              || XWINT (x12, 0) != 7LL)
            return -1;
          return 0;

        case 8LL:
          if (XWINT (x6, 0) != 9LL
              || XWINT (x7, 0) != 10LL
              || XWINT (x8, 0) != 11LL
              || XWINT (x9, 0) != 12LL
              || XWINT (x10, 0) != 13LL
              || XWINT (x11, 0) != 14LL
              || XWINT (x12, 0) != 15LL)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 4:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != CONST_INT
          || !register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0LL:
          if (XWINT (x6, 0) != 1LL
              || XWINT (x7, 0) != 2LL
              || XWINT (x8, 0) != 3LL)
            return -1;
          return 2;

        case 4LL:
          if (XWINT (x6, 0) != 5LL
              || XWINT (x7, 0) != 6LL
              || XWINT (x8, 0) != 7LL)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 2:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      x6 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x6) != CONST_INT
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      switch (XWINT (x5, 0))
        {
        case 0LL:
          if (XWINT (x6, 0) != 1LL)
            return -1;
          return 4;

        case 2LL:
          if (XWINT (x6, 0) != 3LL)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern155 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[1], E_DImode)
          || !general_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!nonimmediate_operand (operands[1], E_SImode)
          || !general_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern162 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern167 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern172 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != LABEL_REF)
    return -1;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  return pattern170 (); /* [-1, 1] */
}

int
pattern177 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != i1)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_TFmode:
          return pattern176 (x3, 
E_TFmode); /* [-1, 0] */

        case E_FPRX2mode:
          if (pattern176 (x3, 
E_FPRX2mode) != 0)
            return -1;
          return 1;

        case E_DFmode:
          if (pattern176 (x3, 
E_DFmode) != 0)
            return -1;
          return 2;

        case E_SFmode:
          if (pattern176 (x3, 
E_SFmode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CLOBBER:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x6 = XVECEXP (x1, 0, 0);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      switch (GET_MODE (x8))
        {
        case E_TFmode:
          if (!register_operand (operands[1], E_TFmode)
              || !const0_operand (operands[2], E_TFmode)
              || !scratch_operand (operands[0], E_TFmode))
            return -1;
          return 4;

        case E_FPRX2mode:
          if (!register_operand (operands[1], E_FPRX2mode)
              || !const0_operand (operands[2], E_FPRX2mode)
              || !scratch_operand (operands[0], E_FPRX2mode))
            return -1;
          return 5;

        case E_DFmode:
          if (!register_operand (operands[1], E_DFmode)
              || !const0_operand (operands[2], E_DFmode)
              || !scratch_operand (operands[0], E_DFmode))
            return -1;
          return 6;

        case E_SFmode:
          if (!register_operand (operands[1], E_SFmode)
              || !const0_operand (operands[2], E_SFmode)
              || !scratch_operand (operands[0], E_SFmode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern204 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern219 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern227 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern237 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern241 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern247 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s390_alc_comparison (operands[3], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern256 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !const0_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern264 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !immediate_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !nonzero_shift_count_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern273 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern278 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern288 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || pattern285 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern295 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pattern25 (x1, 
E_CCRAWmode) != 0)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 347; /* *vec_test_maskv16qi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 348; /* *vec_test_maskv8hi */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 349; /* *vec_test_maskv4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 350; /* *vec_test_maskv2di */

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 351; /* *vec_test_maskv1ti */

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 352; /* *vec_test_maskti */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 353; /* *vec_test_maskv2df */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 354; /* *vec_test_maskv4sf */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || !register_operand (operands[1], E_V1TImode)
          || !(
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 34 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 355; /* *vec_test_maskv1tf */

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TImode)
          || !(
#line 1244 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 35 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
        return -1;
      return 356; /* *vec_test_masktf */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern24 (x1))
    {
    case 0:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1097; /* *vec_slbv16qi */

    case 1:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1098; /* *vec_slbv8hi */

    case 2:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1099; /* *vec_slbv4si */

    case 3:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1100; /* *vec_slbv2di */

    case 4:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1101; /* *vec_slbv1ti */

    case 5:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1102; /* *vec_slbti */

    case 6:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1103; /* *vec_slbv4sf */

    case 7:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1104; /* *vec_slbv2df */

    case 8:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1105; /* *vec_slbv1tf */

    case 9:
      if (!
#line 1590 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1106; /* *vec_slbtf */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != PARALLEL)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x8 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      switch (XWINT (x8, 0))
        {
        case 0LL:
          switch (XWINT (x9, 0))
            {
            case 3LL:
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (pattern220 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                      || !
#line 786 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 657; /* vpdi1v2di */

                case E_V2DFmode:
                  if (pattern220 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                      || !
#line 786 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 658; /* vpdi1v2df */

                default:
                  return -1;
                }

            case 2LL:
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (pattern220 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                      || !
#line 913 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 673; /* *vmrhg */

                case E_V2DFmode:
                  if (pattern220 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                      || !
#line 913 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 674; /* *vmrhg */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1LL:
          switch (XWINT (x9, 0))
            {
            case 2LL:
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (pattern220 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                      || !
#line 798 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 659; /* vpdi4v2di */

                case E_V2DFmode:
                  if (pattern220 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                      || !
#line 798 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 660; /* vpdi4v2df */

                default:
                  return -1;
                }

            case 3LL:
              switch (GET_MODE (operands[0]))
                {
                case E_V2DImode:
                  if (pattern220 (x2, 
E_V2DImode, 
E_V4DImode) != 0
                      || !
#line 923 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 675; /* *vmrlg */

                case E_V2DFmode:
                  if (pattern220 (x2, 
E_V2DFmode, 
E_V4DFmode) != 0
                      || !
#line 923 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 676; /* *vmrlg */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      x8 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x8) != CONST_INT)
        return -1;
      x9 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x9) != CONST_INT)
        return -1;
      x10 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x10) != CONST_INT)
        return -1;
      x11 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      switch (XWINT (x8, 0))
        {
        case 2LL:
          switch (XWINT (x9, 0))
            {
            case 3LL:
              if (XWINT (x10, 0) != 4LL
                  || XWINT (x11, 0) != 5LL)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern220 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 661; /* vpdi4_2v4si */

                case E_V4SFmode:
                  if (pattern220 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 662; /* vpdi4_2v4sf */

                default:
                  return -1;
                }

            case 6LL:
              if (XWINT (x10, 0) != 3LL
                  || XWINT (x11, 0) != 7LL)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern220 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 903 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 671; /* *vmrlf */

                case E_V4SFmode:
                  if (pattern220 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 903 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 672; /* *vmrlf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 0LL:
          if (XWINT (x10, 0) != 1LL)
            return -1;
          switch (XWINT (x9, 0))
            {
            case 4LL:
              if (XWINT (x11, 0) != 5LL)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern220 (x2, 
E_V4SImode, 
E_V8SImode) != 0
                      || !
#line 881 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 667; /* *vmrhf */

                case E_V4SFmode:
                  if (pattern220 (x2, 
E_V4SFmode, 
E_V8SFmode) != 0
                      || !
#line 881 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 668; /* *vmrhf */

                default:
                  return -1;
                }

            case 2LL:
              if (XWINT (x11, 0) != 3LL)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern107 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                      || !
#line 892 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 669; /* *vmrhf_halfv4si */

                case E_V4SFmode:
                  if (pattern107 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                      || !
#line 892 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                    return -1;
                  return 670; /* *vmrhf_halfv4sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 16:
      if (pattern129 (x3) != 0)
        return -1;
      x12 = XVECEXP (x3, 0, 8);
      if (GET_CODE (x12) != CONST_INT)
        return -1;
      x13 = XVECEXP (x3, 0, 9);
      if (GET_CODE (x13) != CONST_INT)
        return -1;
      x14 = XVECEXP (x3, 0, 10);
      if (GET_CODE (x14) != CONST_INT)
        return -1;
      x15 = XVECEXP (x3, 0, 11);
      if (GET_CODE (x15) != CONST_INT)
        return -1;
      x16 = XVECEXP (x3, 0, 12);
      if (GET_CODE (x16) != CONST_INT)
        return -1;
      x17 = XVECEXP (x3, 0, 13);
      if (GET_CODE (x17) != CONST_INT)
        return -1;
      x18 = XVECEXP (x3, 0, 14);
      if (GET_CODE (x18) != CONST_INT)
        return -1;
      x19 = XVECEXP (x3, 0, 15);
      if (GET_CODE (x19) != CONST_INT
          || pattern220 (x2, 
E_V16QImode, 
E_V32QImode) != 0)
        return -1;
      x8 = XVECEXP (x3, 0, 0);
      switch (XWINT (x8, 0))
        {
        case 0LL:
          x9 = XVECEXP (x3, 0, 1);
          if (XWINT (x9, 0) != 16LL)
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (XWINT (x10, 0) != 1LL)
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (XWINT (x11, 0) != 17LL)
            return -1;
          x20 = XVECEXP (x3, 0, 4);
          if (XWINT (x20, 0) != 2LL)
            return -1;
          x21 = XVECEXP (x3, 0, 5);
          if (XWINT (x21, 0) != 18LL)
            return -1;
          x22 = XVECEXP (x3, 0, 6);
          if (XWINT (x22, 0) != 3LL)
            return -1;
          x23 = XVECEXP (x3, 0, 7);
          if (XWINT (x23, 0) != 19LL
              || XWINT (x12, 0) != 4LL
              || XWINT (x13, 0) != 20LL
              || XWINT (x14, 0) != 5LL
              || XWINT (x15, 0) != 21LL
              || XWINT (x16, 0) != 6LL
              || XWINT (x17, 0) != 22LL
              || XWINT (x18, 0) != 7LL
              || XWINT (x19, 0) != 23LL
              || !
#line 827 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 663; /* *vmrhb */

        case 8LL:
          x9 = XVECEXP (x3, 0, 1);
          if (XWINT (x9, 0) != 24LL)
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (XWINT (x10, 0) != 9LL)
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (XWINT (x11, 0) != 25LL)
            return -1;
          x20 = XVECEXP (x3, 0, 4);
          if (XWINT (x20, 0) != 10LL)
            return -1;
          x21 = XVECEXP (x3, 0, 5);
          if (XWINT (x21, 0) != 26LL)
            return -1;
          x22 = XVECEXP (x3, 0, 6);
          if (XWINT (x22, 0) != 11LL)
            return -1;
          x23 = XVECEXP (x3, 0, 7);
          if (XWINT (x23, 0) != 27LL
              || XWINT (x12, 0) != 12LL
              || XWINT (x13, 0) != 28LL
              || XWINT (x14, 0) != 13LL
              || XWINT (x15, 0) != 29LL
              || XWINT (x16, 0) != 14LL
              || XWINT (x17, 0) != 30LL
              || XWINT (x18, 0) != 15LL
              || XWINT (x19, 0) != 31LL
              || !
#line 844 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 664; /* *vmrlb */

        default:
          return -1;
        }

    case 8:
      if (pattern129 (x3) != 0
          || pattern220 (x2, 
E_V8HImode, 
E_V16HImode) != 0)
        return -1;
      x8 = XVECEXP (x3, 0, 0);
      switch (XWINT (x8, 0))
        {
        case 0LL:
          x9 = XVECEXP (x3, 0, 1);
          if (XWINT (x9, 0) != 8LL)
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (XWINT (x10, 0) != 1LL)
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (XWINT (x11, 0) != 9LL)
            return -1;
          x20 = XVECEXP (x3, 0, 4);
          if (XWINT (x20, 0) != 2LL)
            return -1;
          x21 = XVECEXP (x3, 0, 5);
          if (XWINT (x21, 0) != 10LL)
            return -1;
          x22 = XVECEXP (x3, 0, 6);
          if (XWINT (x22, 0) != 3LL)
            return -1;
          x23 = XVECEXP (x3, 0, 7);
          if (XWINT (x23, 0) != 11LL
              || !
#line 857 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 665; /* *vmrhh */

        case 4LL:
          x9 = XVECEXP (x3, 0, 1);
          if (XWINT (x9, 0) != 12LL)
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          if (XWINT (x10, 0) != 5LL)
            return -1;
          x11 = XVECEXP (x3, 0, 3);
          if (XWINT (x11, 0) != 13LL)
            return -1;
          x20 = XVECEXP (x3, 0, 4);
          if (XWINT (x20, 0) != 6LL)
            return -1;
          x21 = XVECEXP (x3, 0, 5);
          if (XWINT (x21, 0) != 14LL)
            return -1;
          x22 = XVECEXP (x3, 0, 6);
          if (XWINT (x22, 0) != 7LL)
            return -1;
          x23 = XVECEXP (x3, 0, 7);
          if (XWINT (x23, 0) != 15LL
              || !
#line 870 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 666; /* *vmrlh */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[3] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (pattern204 (x2, 
E_V1QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1QImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1413; /* vec_sel0v1qi */
      if (!all_ones_operand (operands[4], E_V1QImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1454; /* *vec_sel1v1qi */

    case E_V2QImode:
      if (pattern204 (x2, 
E_V2QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2QImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1414; /* vec_sel0v2qi */
      if (!all_ones_operand (operands[4], E_V2QImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1455; /* *vec_sel1v2qi */

    case E_V4QImode:
      if (pattern204 (x2, 
E_V4QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4QImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1415; /* vec_sel0v4qi */
      if (!all_ones_operand (operands[4], E_V4QImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1456; /* *vec_sel1v4qi */

    case E_V8QImode:
      if (pattern204 (x2, 
E_V8QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V8QImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1416; /* vec_sel0v8qi */
      if (!all_ones_operand (operands[4], E_V8QImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1457; /* *vec_sel1v8qi */

    case E_V16QImode:
      if (pattern204 (x2, 
E_V16QImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V16QImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1417; /* vec_sel0v16qi */
      if (!all_ones_operand (operands[4], E_V16QImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1458; /* *vec_sel1v16qi */

    case E_V1HImode:
      if (pattern204 (x2, 
E_V1HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1HImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1418; /* vec_sel0v1hi */
      if (!all_ones_operand (operands[4], E_V1HImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1459; /* *vec_sel1v1hi */

    case E_V2HImode:
      if (pattern204 (x2, 
E_V2HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2HImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1419; /* vec_sel0v2hi */
      if (!all_ones_operand (operands[4], E_V2HImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1460; /* *vec_sel1v2hi */

    case E_V4HImode:
      if (pattern204 (x2, 
E_V4HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4HImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1420; /* vec_sel0v4hi */
      if (!all_ones_operand (operands[4], E_V4HImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1461; /* *vec_sel1v4hi */

    case E_V8HImode:
      if (pattern204 (x2, 
E_V8HImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V8HImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1421; /* vec_sel0v8hi */
      if (!all_ones_operand (operands[4], E_V8HImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1462; /* *vec_sel1v8hi */

    case E_V1SImode:
      if (pattern204 (x2, 
E_V1SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1SImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1422; /* vec_sel0v1si */
      if (!all_ones_operand (operands[4], E_V1SImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1463; /* *vec_sel1v1si */

    case E_V2SImode:
      if (pattern204 (x2, 
E_V2SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2SImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1423; /* vec_sel0v2si */
      if (!all_ones_operand (operands[4], E_V2SImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1464; /* *vec_sel1v2si */

    case E_V4SImode:
      if (pattern204 (x2, 
E_V4SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4SImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1424; /* vec_sel0v4si */
      if (!all_ones_operand (operands[4], E_V4SImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1465; /* *vec_sel1v4si */

    case E_V1DImode:
      if (pattern204 (x2, 
E_V1DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1DImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1425; /* vec_sel0v1di */
      if (!all_ones_operand (operands[4], E_V1DImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1466; /* *vec_sel1v1di */

    case E_V2DImode:
      if (pattern204 (x2, 
E_V2DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2DImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1426; /* vec_sel0v2di */
      if (!all_ones_operand (operands[4], E_V2DImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1467; /* *vec_sel1v2di */

    case E_V1SFmode:
      if (pattern205 (x2, 
E_V1SFmode, 
E_V1SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1SImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1427; /* vec_sel0v1sf */
      if (!all_ones_operand (operands[4], E_V1SImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1468; /* *vec_sel1v1sf */

    case E_V2SFmode:
      if (pattern205 (x2, 
E_V2SFmode, 
E_V2SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2SImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1428; /* vec_sel0v2sf */
      if (!all_ones_operand (operands[4], E_V2SImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1469; /* *vec_sel1v2sf */

    case E_V4SFmode:
      if (pattern205 (x2, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V4SImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1429; /* vec_sel0v4sf */
      if (!all_ones_operand (operands[4], E_V4SImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1470; /* *vec_sel1v4sf */

    case E_V1DFmode:
      if (pattern205 (x2, 
E_V1DFmode, 
E_V1DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V1DImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1430; /* vec_sel0v1df */
      if (!all_ones_operand (operands[4], E_V1DImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1471; /* *vec_sel1v1df */

    case E_V2DFmode:
      if (pattern205 (x2, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      if (const0_operand (operands[4], E_V2DImode)
          && 
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return 1431; /* vec_sel0v2df */
      if (!all_ones_operand (operands[4], E_V2DImode)
          || !
#line 2578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1472; /* *vec_sel1v2df */

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x2) != E_V1TFmode
          || !register_operand (operands[3], E_V1TImode)
          || !const0_operand (operands[4], E_V1TImode)
          || !register_operand (operands[1], E_V1TFmode)
          || !register_operand (operands[2], E_V1TFmode)
          || !
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1432; /* vec_sel0v1tf */

    case E_V1TImode:
      if (pattern206 (x2, 
E_V1TImode) != 0
          || !
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1433; /* vec_sel0v1ti */

    case E_TImode:
      if (pattern206 (x2, 
E_TImode) != 0
          || !
#line 2554 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1434; /* vec_sel0ti */

    default:
      return -1;
    }
}

 int
recog_40 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!nonimmediate_operand (operands[0], E_V16QImode)
          || !general_operand (operands[1], E_V16QImode))
        return -1;
      return 521; /* movv16qi */

    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || !general_operand (operands[1], E_V8HImode))
        return -1;
      return 522; /* movv8hi */

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || !general_operand (operands[1], E_V4SImode))
        return -1;
      return 523; /* movv4si */

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !general_operand (operands[1], E_V4SFmode))
        return -1;
      return 524; /* movv4sf */

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || !general_operand (operands[1], E_V2DImode))
        return -1;
      return 525; /* movv2di */

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !general_operand (operands[1], E_V2DFmode))
        return -1;
      return 526; /* movv2df */

    case E_V1TImode:
      if (!nonimmediate_operand (operands[0], E_V1TImode)
          || !general_operand (operands[1], E_V1TImode))
        return -1;
      return 527; /* movv1ti */

    case E_V1TFmode:
      if (!nonimmediate_operand (operands[0], E_V1TFmode)
          || !general_operand (operands[1], E_V1TFmode))
        return -1;
      return 528; /* movv1tf */

    case E_TFmode:
      if (!nonimmediate_operand (operands[0], E_TFmode)
          || !general_operand (operands[1], E_TFmode)
          || !
#line 95 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 529; /* movtf_vr */

    case E_V1QImode:
      if (!nonimmediate_operand (operands[0], E_V1QImode)
          || !general_operand (operands[1], E_V1QImode)
          || !
#line 370 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 530; /* movv1qi */

    case E_V2QImode:
      if (!nonimmediate_operand (operands[0], E_V2QImode)
          || !general_operand (operands[1], E_V2QImode))
        return -1;
      return 531; /* movv2qi */

    case E_V1HImode:
      if (!nonimmediate_operand (operands[0], E_V1HImode)
          || !general_operand (operands[1], E_V1HImode))
        return -1;
      return 532; /* movv1hi */

    case E_V4QImode:
      if (!nonimmediate_operand (operands[0], E_V4QImode)
          || !general_operand (operands[1], E_V4QImode)
          || !
#line 425 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 533; /* movv4qi */

    case E_V2HImode:
      if (!nonimmediate_operand (operands[0], E_V2HImode)
          || !general_operand (operands[1], E_V2HImode)
          || !
#line 425 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 534; /* movv2hi */

    case E_V1SImode:
      if (!nonimmediate_operand (operands[0], E_V1SImode)
          || !general_operand (operands[1], E_V1SImode)
          || !
#line 425 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 535; /* movv1si */

    case E_V1SFmode:
      if (!nonimmediate_operand (operands[0], E_V1SFmode)
          || !general_operand (operands[1], E_V1SFmode)
          || !
#line 425 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 536; /* movv1sf */

    case E_V8QImode:
      if (!nonimmediate_operand (operands[0], E_V8QImode)
          || !general_operand (operands[1], E_V8QImode)
          || !
#line 462 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 537; /* movv8qi */

    case E_V4HImode:
      if (!nonimmediate_operand (operands[0], E_V4HImode)
          || !general_operand (operands[1], E_V4HImode)
          || !
#line 462 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 538; /* movv4hi */

    case E_V2SImode:
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !general_operand (operands[1], E_V2SImode)
          || !
#line 462 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 539; /* movv2si */

    case E_V2SFmode:
      if (!nonimmediate_operand (operands[0], E_V2SFmode)
          || !general_operand (operands[1], E_V2SFmode)
          || !
#line 462 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 540; /* movv2sf */

    case E_V1DImode:
      if (!nonimmediate_operand (operands[0], E_V1DImode)
          || !general_operand (operands[1], E_V1DImode)
          || !
#line 462 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 541; /* movv1di */

    case E_V1DFmode:
      if (!nonimmediate_operand (operands[0], E_V1DFmode)
          || !general_operand (operands[1], E_V1DFmode)
          || !
#line 462 "../../gcc/config/s390/vector.md"
(TARGET_ZARCH))
        return -1;
      return 542; /* movv1df */

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !reload_const_wide_int_operand (operands[1], E_TImode)
          || !
#line 1757 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 1809; /* *movti_bigconst */

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !general_operand (operands[1], E_DImode))
        return -1;
      if (
#line 1972 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1811; /* *movdi_64 */
      if (!
#line 2213 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1844; /* *movdi_31 */

    case E_SImode:
      if (register_operand (operands[0], E_SImode)
          && larl_operand (operands[1], E_SImode)
          && 
#line 2394 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT
   && !FP_REG_P (operands[0])))
        return 1846; /* *movsi_larl */
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !general_operand (operands[1], E_SImode))
        return -1;
      if (
#line 2407 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1847; /* *movsi_zarch */
      if (!
#line 2498 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1848; /* *movsi_esa */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !general_operand (operands[1], E_HImode))
        return -1;
      return 1853; /* *movhi */

    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !general_operand (operands[1], E_QImode))
        return -1;
      return 1854; /* *movqi */

    case E_FPRX2mode:
      if (!nonimmediate_operand (operands[0], E_FPRX2mode)
          || !general_operand (operands[1], E_FPRX2mode))
        return -1;
      if ((
#line 2793 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 764 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return 1859; /* *movfprx2_64 */
      if (!(
#line 2810 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 764 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
        return -1;
      return 1862; /* *movfprx2_31 */

    case E_TDmode:
      if (!nonimmediate_operand (operands[0], E_TDmode)
          || !general_operand (operands[1], E_TDmode))
        return -1;
      if (
#line 2793 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1860; /* *movtd_64 */
      if (!
#line 2810 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1863; /* *movtd_31 */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !general_operand (operands[1], E_DFmode))
        return -1;
      if (
#line 2917 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
        return 1864; /* *movdf_64dfp */
      if (
#line 2949 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1866; /* *movdf_64 */
      if (!
#line 2975 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1868; /* *movdf_31 */

    case E_DDmode:
      if (!nonimmediate_operand (operands[0], E_DDmode)
          || !general_operand (operands[1], E_DDmode))
        return -1;
      if (
#line 2917 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
        return 1865; /* *movdd_64dfp */
      if (
#line 2949 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return 1867; /* *movdd_64 */
      if (!
#line 2975 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        return -1;
      return 1869; /* *movdd_31 */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !general_operand (operands[1], E_SFmode))
        return -1;
      return 1870; /* movsf */

    case E_SDmode:
      if (!nonimmediate_operand (operands[0], E_SDmode)
          || !general_operand (operands[1], E_SDmode))
        return -1;
      return 1871; /* movsd */

    case E_CCmode:
      if (!nonimmediate_operand (operands[0], E_CCmode)
          || !nonimmediate_operand (operands[1], E_CCmode))
        return -1;
      return 1872; /* movcc */

    default:
      return -1;
    }
}

 int
recog_57 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      return recog_22 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_23 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (pattern65 (x3, pnum_clobbers))
        {
        case 0:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 816; /* iorv1qi3 */
          break;

        case 1:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 817; /* iorv2qi3 */
          break;

        case 2:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 818; /* iorv4qi3 */
          break;

        case 3:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 819; /* iorv8qi3 */
          break;

        case 4:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 820; /* iorv16qi3 */
          break;

        case 5:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 821; /* iorv1hi3 */
          break;

        case 6:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 822; /* iorv2hi3 */
          break;

        case 7:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 823; /* iorv4hi3 */
          break;

        case 8:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 824; /* iorv8hi3 */
          break;

        case 9:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 825; /* iorv1si3 */
          break;

        case 10:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 826; /* iorv2si3 */
          break;

        case 11:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 827; /* iorv4si3 */
          break;

        case 12:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 828; /* iorv1di3 */
          break;

        case 13:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 829; /* iorv2di3 */
          break;

        case 14:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 830; /* iorv1sf3 */
          break;

        case 15:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 831; /* iorv2sf3 */
          break;

        case 16:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 832; /* iorv4sf3 */
          break;

        case 17:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 833; /* iorv1df3 */
          break;

        case 18:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 834; /* iorv2df3 */
          break;

        case 19:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 835; /* iorv1tf3 */
          break;

        case 20:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 836; /* iorv1ti3 */
          break;

        case 21:
          if (
#line 1276 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 837; /* iorti3 */
          break;

        case 22:
          if (
#line 8366 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2364; /* *iordi3 */
            }
          break;

        case 23:
          if (
#line 8503 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2369; /* *iorhi3_zarch */
            }
          if (
#line 8519 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2370; /* *iorhi3_esa */
            }
          break;

        case 24:
          if (
#line 8546 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2371; /* *iorqi3_zarch */
            }
          if (
#line 8564 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            {
              *pnum_clobbers = 1;
              return 2372; /* *iorqi3_esa */
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL
          || !nonimmediate_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      if (GET_CODE (x4) == SUBREG
          && pattern131 (x3) == 0
          && 
#line 4788 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        {
          *pnum_clobbers = 1;
          return 1996; /* *rosbg_sidi_srl */
        }
      operands[1] = x4;
      if (!nonimmediate_operand (operands[1], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      if (
#line 8447 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        {
          *pnum_clobbers = 1;
          return 2367; /* *iorsi3_zarch */
        }
      if (!
#line 8475 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      *pnum_clobbers = 1;
      return 2368; /* *iorsi3_esa */

    case IOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1577; /* *vevalv1qi_iorior */

        case 1:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1586; /* *vevalv2qi_iorior */

        case 2:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1595; /* *vevalv4qi_iorior */

        case 3:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1604; /* *vevalv8qi_iorior */

        case 4:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1613; /* *vevalv16qi_iorior */

        case 5:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1622; /* *vevalv1hi_iorior */

        case 6:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1631; /* *vevalv2hi_iorior */

        case 7:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1640; /* *vevalv4hi_iorior */

        case 8:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1649; /* *vevalv8hi_iorior */

        case 9:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1658; /* *vevalv1si_iorior */

        case 10:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1667; /* *vevalv2si_iorior */

        case 11:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1676; /* *vevalv4si_iorior */

        case 12:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1685; /* *vevalv1di_iorior */

        case 13:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1694; /* *vevalv2di_iorior */

        case 14:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1703; /* *vevalv1ti_iorior */

        case 15:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1712; /* *vevalti_iorior */

        default:
          return -1;
        }

    case XOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1578; /* *vevalv1qi_iorxor */

        case 1:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1587; /* *vevalv2qi_iorxor */

        case 2:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1596; /* *vevalv4qi_iorxor */

        case 3:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1605; /* *vevalv8qi_iorxor */

        case 4:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1614; /* *vevalv16qi_iorxor */

        case 5:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1623; /* *vevalv1hi_iorxor */

        case 6:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1632; /* *vevalv2hi_iorxor */

        case 7:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1641; /* *vevalv4hi_iorxor */

        case 8:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1650; /* *vevalv8hi_iorxor */

        case 9:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1659; /* *vevalv1si_iorxor */

        case 10:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1668; /* *vevalv2si_iorxor */

        case 11:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1677; /* *vevalv4si_iorxor */

        case 12:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1686; /* *vevalv1di_iorxor */

        case 13:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1695; /* *vevalv2di_iorxor */

        case 14:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1704; /* *vevalv1ti_iorxor */

        case 15:
          if (!
#line 3400 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 1713; /* *vevalti_iorxor */

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern31 (x3, pnum_clobbers))
            {
            case 0:
              if (!(
#line 4749 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              *pnum_clobbers = 1;
              return 1988; /* *rosbg_di_sll */

            case 1:
              if (!
#line 4749 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              *pnum_clobbers = 1;
              return 1990; /* *rosbg_si_sll */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x7 = XEXP (x4, 1);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          x5 = XEXP (x3, 1);
          if (GET_CODE (x5) != ZERO_EXTEND)
            return -1;
          x8 = XEXP (x6, 0);
          switch (GET_CODE (x8))
            {
            case MOD:
              if (pattern132 (x3, 
DIV) != 0
                  || pattern203 (x3) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x11 = XEXP (x8, 1);
              switch (GET_CODE (x11))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case MEM:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[2] = x11;
                  if (!general_operand (operands[2], E_DImode))
                    return -1;
                  x12 = XEXP (x9, 1);
                  if (!rtx_equal_p (x12, operands[2])
                      || !
#line 7666 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  return 2329; /* divmodtidi3 */

                case SIGN_EXTEND:
                  if (GET_MODE (x11) != E_DImode)
                    return -1;
                  x12 = XEXP (x9, 1);
                  if (GET_CODE (x12) != SIGN_EXTEND
                      || GET_MODE (x12) != E_DImode)
                    return -1;
                  x13 = XEXP (x11, 0);
                  operands[2] = x13;
                  if (!nonimmediate_operand (operands[2], E_SImode))
                    return -1;
                  x14 = XEXP (x12, 0);
                  if (!rtx_equal_p (x14, operands[2])
                      || !
#line 7684 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return -1;
                  return 2330; /* divmodtisi3 */

                default:
                  return -1;
                }

            case TRUNCATE:
              x9 = XEXP (x5, 0);
              if (GET_CODE (x9) != TRUNCATE)
                return -1;
              x15 = XEXP (x8, 0);
              switch (GET_CODE (x15))
                {
                case UMOD:
                  x16 = XEXP (x15, 1);
                  if (GET_CODE (x16) != ZERO_EXTEND)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != UDIV)
                    return -1;
                  x17 = XEXP (x10, 1);
                  if (GET_CODE (x17) != ZERO_EXTEND)
                    return -1;
                  x18 = XEXP (x15, 0);
                  operands[1] = x18;
                  x19 = XEXP (x16, 0);
                  operands[2] = x19;
                  x20 = XEXP (x10, 0);
                  if (!rtx_equal_p (x20, operands[1]))
                    return -1;
                  x21 = XEXP (x17, 0);
                  if (!rtx_equal_p (x21, operands[2]))
                    return -1;
                  switch (XWINT (x7, 0))
                    {
                    case 64LL:
                      if (pattern269 (x3, 
E_TImode, 
E_DImode) != 0
                          || !
#line 7745 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                        return -1;
                      return 2331; /* udivmodtidi3 */

                    case 32LL:
                      if (pattern269 (x3, 
E_DImode, 
E_SImode) != 0
                          || !
#line 7865 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                        return -1;
                      return 2333; /* udivmoddisi3 */

                    default:
                      return -1;
                    }

                case MOD:
                  if (GET_MODE (x15) != E_DImode)
                    return -1;
                  x16 = XEXP (x15, 1);
                  if (GET_CODE (x16) != SIGN_EXTEND
                      || GET_MODE (x16) != E_DImode
                      || XWINT (x7, 0) != 32LL)
                    return -1;
                  x10 = XEXP (x9, 0);
                  if (GET_CODE (x10) != DIV
                      || GET_MODE (x10) != E_DImode)
                    return -1;
                  x17 = XEXP (x10, 1);
                  if (GET_CODE (x17) != SIGN_EXTEND
                      || GET_MODE (x17) != E_DImode
                      || !register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || GET_MODE (x4) != E_DImode
                      || GET_MODE (x6) != E_DImode
                      || GET_MODE (x8) != E_SImode)
                    return -1;
                  x18 = XEXP (x15, 0);
                  operands[1] = x18;
                  if (!register_operand (operands[1], E_DImode))
                    return -1;
                  x19 = XEXP (x16, 0);
                  operands[2] = x19;
                  if (!nonimmediate_operand (operands[2], E_SImode)
                      || GET_MODE (x5) != E_DImode
                      || GET_MODE (x9) != E_SImode)
                    return -1;
                  x20 = XEXP (x10, 0);
                  if (!rtx_equal_p (x20, operands[1]))
                    return -1;
                  x21 = XEXP (x17, 0);
                  if (!rtx_equal_p (x21, operands[2])
                      || !
#line 7804 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                    return -1;
                  return 2332; /* divmoddisi3 */

                default:
                  return -1;
                }

            case CLZ:
              if (pnum_clobbers == NULL
                  || pattern132 (x3, 
XOR) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x12 = XEXP (x9, 1);
              if (GET_CODE (x12) != LSHIFTRT)
                return -1;
              x22 = XEXP (x12, 1);
              if (GET_CODE (x22) != SUBREG
                  || maybe_ne (SUBREG_BYTE (x22), 4)
                  || GET_MODE (x22) != E_SImode)
                return -1;
              x23 = XEXP (x22, 0);
              if (GET_CODE (x23) != CLZ
                  || GET_MODE (x23) != E_DImode
                  || pattern203 (x3) != 0)
                return -1;
              x14 = XEXP (x12, 0);
              operands[2] = x14;
              if (!const_int_operand (operands[2], E_DImode))
                return -1;
              x10 = XEXP (x9, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              x24 = XEXP (x23, 0);
              if (!rtx_equal_p (x24, operands[1])
                  || !
#line 9623 "../../gcc/config/s390/s390.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_1U << 63
   && TARGET_EXTIMM && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2500; /* clztidi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern31 (x3, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4768 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1992; /* *rosbg_di_srl */

        case 1:
          if (!
#line 4768 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1994; /* *rosbg_si_srl */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (XVECLEN (x5, 0))
        {
        case 2:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x8 = XVECEXP (x5, 0, 1);
          if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 2]
              || pattern140 (x3, 
E_V4SFmode, 
E_V2SFmode, 
E_V2DFmode) != 0
              || !
#line 2810 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1523; /* *vec_extendv4sf */

        case 1:
          x7 = XVECEXP (x5, 0, 0);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || pattern140 (x3, 
E_V2DFmode, 
E_V1DFmode, 
E_V1TFmode) != 0
              || !
#line 2854 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1524; /* *vec_extendv2df */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (register_operand (operands[1], E_DFmode)
                  && 
#line 3177 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
                return 1558; /* extenddftf2_vr */
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !(
#line 5784 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (TFmode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || TFmode != DFmode || DFmode != SFmode)) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2096; /* *extenddftf2 */

            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode)
                  || !(
#line 5784 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (TFmode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || TFmode != DFmode || SFmode != SFmode)) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2100; /* *extendsftf2 */

            default:
              return -1;
            }

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_SFmode:
              if (!nonimmediate_operand (operands[1], E_SFmode))
                return -1;
              if (
#line 5772 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
                return 2095; /* *extendsfdf2_z13 */
              if (!
#line 5784 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (DFmode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || DFmode != DFmode || SFmode != SFmode)))
                return -1;
              return 2102; /* *extendsfdf2 */

            case E_DFmode:
              if (!nonimmediate_operand (operands[1], E_DFmode)
                  || !
#line 5784 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (DFmode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || DFmode != DFmode || DFmode != SFmode)))
                return -1;
              return 2098; /* *extenddfdf2 */

            default:
              return -1;
            }

        case E_FPRX2mode:
          switch (pattern87 (x3, 
E_FPRX2mode))
            {
            case 0:
              if (!(
#line 5784 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (FPRX2mode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || FPRX2mode != DFmode || DFmode != SFmode)) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2097; /* *extenddffprx22 */

            case 1:
              if (!(
#line 5784 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (FPRX2mode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || FPRX2mode != DFmode || SFmode != SFmode)) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2101; /* *extendsffprx22 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern87 (x3, 
E_SFmode))
            {
            case 0:
              if (!
#line 5784 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (SFmode) > GET_MODE_SIZE (DFmode)
   && (!TARGET_VX || SFmode != DFmode || DFmode != SFmode)))
                return -1;
              return 2099; /* *extenddfsf2 */

            case 1:
              if (!
#line 5784 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT
   && GET_MODE_SIZE (SFmode) > GET_MODE_SIZE (SFmode)
   && (!TARGET_VX || SFmode != DFmode || SFmode != SFmode)))
                return -1;
              return 2103; /* *extendsfsf2 */

            default:
              return -1;
            }

        case E_TDmode:
          if (!register_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !register_operand (operands[1], E_DDmode)
              || !
#line 5806 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2104; /* extendddtd2 */

        case E_DDmode:
          if (!register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_SDmode)
              || !
#line 5814 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2105; /* extendsddd2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_79 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 0);
      switch (GET_MODE (x5))
        {
        case E_CCVEQmode:
          x6 = XEXP (x4, 1);
          if (GET_MODE (x6) != E_CCVEQmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (!register_operand (operands[0], E_V16QImode)
                  || !register_operand (operands[1], E_V16QImode)
                  || !scratch_operand (operands[2], E_V16QImode)
                  || !
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 413; /* *vec_cmpeqv16qi_cconly */

            case E_V8HImode:
              if (!register_operand (operands[0], E_V8HImode)
                  || !register_operand (operands[1], E_V8HImode)
                  || !scratch_operand (operands[2], E_V8HImode)
                  || !
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 416; /* *vec_cmpeqv8hi_cconly */

            case E_V4SImode:
              if (!register_operand (operands[0], E_V4SImode)
                  || !register_operand (operands[1], E_V4SImode)
                  || !scratch_operand (operands[2], E_V4SImode)
                  || !
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 419; /* *vec_cmpeqv4si_cconly */

            case E_V2DImode:
              if (!register_operand (operands[0], E_V2DImode)
                  || !register_operand (operands[1], E_V2DImode)
                  || !scratch_operand (operands[2], E_V2DImode)
                  || !
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 422; /* *vec_cmpeqv2di_cconly */

            case E_V1TImode:
              if (!register_operand (operands[0], E_V1TImode)
                  || !register_operand (operands[1], E_V1TImode)
                  || !scratch_operand (operands[2], E_V1TImode)
                  || !(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 425; /* *vec_cmpeqv1ti_cconly */

            case E_TImode:
              if (!register_operand (operands[0], E_TImode)
                  || !register_operand (operands[1], E_TImode)
                  || !scratch_operand (operands[2], E_TImode)
                  || !(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 428; /* *vec_cmpeqti_cconly */

            case E_V4SFmode:
              if (!register_operand (operands[0], E_V4SFmode)
                  || !register_operand (operands[1], E_V4SFmode)
                  || !scratch_operand (operands[2], E_V4SImode)
                  || !(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 449; /* *vec_cmpeqv4sf_cconly */

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || !register_operand (operands[1], E_V2DFmode)
                  || !scratch_operand (operands[2], E_V2DImode)
                  || !
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 450; /* *vec_cmpeqv2df_cconly */

            case E_V1TFmode:
              if (!register_operand (operands[0], E_V1TFmode)
                  || !register_operand (operands[1], E_V1TFmode)
                  || !scratch_operand (operands[2], E_V1TImode)
                  || !(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 451; /* *vec_cmpeqv1tf_cconly */

            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || !register_operand (operands[1], E_TFmode)
                  || !scratch_operand (operands[2], E_TImode)
                  || !(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 452; /* *vec_cmpeqtf_cconly */

            default:
              return -1;
            }

        case E_CCVIHmode:
          x6 = XEXP (x4, 1);
          switch (pattern234 (x6, 
E_CCVIHmode))
            {
            case 0:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 414; /* *vec_cmphv16qi_cconly */

            case 1:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 417; /* *vec_cmphv8hi_cconly */

            case 2:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 420; /* *vec_cmphv4si_cconly */

            case 3:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 423; /* *vec_cmphv2di_cconly */

            case 4:
              if (!(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 426; /* *vec_cmphv1ti_cconly */

            case 5:
              if (!(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 429; /* *vec_cmphti_cconly */

            default:
              return -1;
            }

        case E_CCVIHUmode:
          x6 = XEXP (x4, 1);
          switch (pattern234 (x6, 
E_CCVIHUmode))
            {
            case 0:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 415; /* *vec_cmphlv16qi_cconly */

            case 1:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 418; /* *vec_cmphlv8hi_cconly */

            case 2:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 421; /* *vec_cmphlv4si_cconly */

            case 3:
              if (!
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 424; /* *vec_cmphlv2di_cconly */

            case 4:
              if (!(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 427; /* *vec_cmphlv1ti_cconly */

            case 5:
              if (!(
#line 1981 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 430; /* *vec_cmphlti_cconly */

            default:
              return -1;
            }

        case E_CCVFHmode:
          x6 = XEXP (x4, 1);
          switch (pattern235 (x6, 
E_CCVFHmode))
            {
            case 0:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 453; /* *vec_cmphv4sf_cconly */

            case 1:
              if (!
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 454; /* *vec_cmphv2df_cconly */

            case 2:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 455; /* *vec_cmphv1tf_cconly */

            case 3:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 456; /* *vec_cmphtf_cconly */

            default:
              return -1;
            }

        case E_CCVFHEmode:
          x6 = XEXP (x4, 1);
          switch (pattern235 (x6, 
E_CCVFHEmode))
            {
            case 0:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 457; /* *vec_cmphev4sf_cconly */

            case 1:
              if (!
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 458; /* *vec_cmphev2df_cconly */

            case 2:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 459; /* *vec_cmphev1tf_cconly */

            case 3:
              if (!(
#line 2064 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 460; /* *vec_cmphetf_cconly */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case EQ:
          if (pattern236 (x1, 
E_CCVEQmode) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern273 (x7, 
E_V16QImode) != 0
                  || !
#line 2030 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 431; /* *vec_cmpeqv16qi_cc */

            case E_V8HImode:
              if (pattern273 (x7, 
E_V8HImode) != 0
                  || !
#line 2030 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 432; /* *vec_cmpeqv8hi_cc */

            case E_V4SImode:
              if (pattern273 (x7, 
E_V4SImode) != 0
                  || !
#line 2030 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 433; /* *vec_cmpeqv4si_cc */

            case E_V2DImode:
              if (pattern273 (x7, 
E_V2DImode) != 0
                  || !
#line 2030 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 434; /* *vec_cmpeqv2di_cc */

            case E_V1TImode:
              if (pattern273 (x7, 
E_V1TImode) != 0
                  || !(
#line 2030 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 435; /* *vec_cmpeqv1ti_cc */

            case E_TImode:
              if (pattern273 (x7, 
E_TImode) != 0
                  || !(
#line 2030 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 436; /* *vec_cmpeqti_cc */

            case E_V4SFmode:
              if (pattern274 (x7, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 2113 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 461; /* *vec_cmpeqv4sf_cc */

            case E_V2DFmode:
              if (pattern274 (x7, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 2113 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 462; /* *vec_cmpeqv2df_cc */

            case E_V1TFmode:
              if (pattern274 (x7, 
E_V1TImode, 
E_V1TFmode) != 0
                  || !(
#line 2113 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 463; /* *vec_cmpeqv1tf_cc */

            case E_TFmode:
              if (pattern274 (x7, 
E_TImode, 
E_TFmode) != 0
                  || !(
#line 2113 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 464; /* *vec_cmpeqtf_cc */

            default:
              return -1;
            }

        case GT:
          x8 = XEXP (x7, 0);
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          x9 = XEXP (x7, 1);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          x4 = XVECEXP (x1, 0, 0);
          x5 = XEXP (x4, 0);
          switch (GET_MODE (x5))
            {
            case E_CCVIHmode:
              x6 = XEXP (x4, 1);
              if (GET_MODE (x6) != E_CCVIHmode)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern273 (x7, 
E_V16QImode) != 0
                      || !
#line 2040 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 437; /* *vec_cmphv16qi_cc */

                case E_V8HImode:
                  if (pattern273 (x7, 
E_V8HImode) != 0
                      || !
#line 2040 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 438; /* *vec_cmphv8hi_cc */

                case E_V4SImode:
                  if (pattern273 (x7, 
E_V4SImode) != 0
                      || !
#line 2040 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 439; /* *vec_cmphv4si_cc */

                case E_V2DImode:
                  if (pattern273 (x7, 
E_V2DImode) != 0
                      || !
#line 2040 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 440; /* *vec_cmphv2di_cc */

                case E_V1TImode:
                  if (pattern273 (x7, 
E_V1TImode) != 0
                      || !(
#line 2040 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                    return -1;
                  return 441; /* *vec_cmphv1ti_cc */

                case E_TImode:
                  if (pattern273 (x7, 
E_TImode) != 0
                      || !(
#line 2040 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                    return -1;
                  return 442; /* *vec_cmphti_cc */

                default:
                  return -1;
                }

            case E_CCVFHmode:
              x6 = XEXP (x4, 1);
              if (GET_MODE (x6) != E_CCVFHmode)
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SFmode:
                  if (pattern274 (x7, 
E_V4SImode, 
E_V4SFmode) != 0
                      || !(
#line 2124 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 465; /* *vec_cmphv4sf_cc */

                case E_V2DFmode:
                  if (pattern274 (x7, 
E_V2DImode, 
E_V2DFmode) != 0
                      || !
#line 2124 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 466; /* *vec_cmphv2df_cc */

                case E_V1TFmode:
                  if (pattern274 (x7, 
E_V1TImode, 
E_V1TFmode) != 0
                      || !(
#line 2124 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 467; /* *vec_cmphv1tf_cc */

                case E_TFmode:
                  if (pattern274 (x7, 
E_TImode, 
E_TFmode) != 0
                      || !(
#line 2124 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 468; /* *vec_cmphtf_cc */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case GTU:
          if (pattern236 (x1, 
E_CCVIHUmode) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern273 (x7, 
E_V16QImode) != 0
                  || !
#line 2050 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 443; /* *vec_cmphlv16qi_cc */

            case E_V8HImode:
              if (pattern273 (x7, 
E_V8HImode) != 0
                  || !
#line 2050 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 444; /* *vec_cmphlv8hi_cc */

            case E_V4SImode:
              if (pattern273 (x7, 
E_V4SImode) != 0
                  || !
#line 2050 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 445; /* *vec_cmphlv4si_cc */

            case E_V2DImode:
              if (pattern273 (x7, 
E_V2DImode) != 0
                  || !
#line 2050 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 446; /* *vec_cmphlv2di_cc */

            case E_V1TImode:
              if (pattern273 (x7, 
E_V1TImode) != 0
                  || !(
#line 2050 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 447; /* *vec_cmphlv1ti_cc */

            case E_TImode:
              if (pattern273 (x7, 
E_TImode) != 0
                  || !(
#line 2050 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return -1;
              return 448; /* *vec_cmphlti_cc */

            default:
              return -1;
            }

        case GE:
          if (pattern236 (x1, 
E_CCVFHEmode) != 0)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern274 (x7, 
E_V4SImode, 
E_V4SFmode) != 0
                  || !(
#line 2135 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 469; /* *vec_cmphev4sf_cc */

            case E_V2DFmode:
              if (pattern274 (x7, 
E_V2DImode, 
E_V2DFmode) != 0
                  || !
#line 2135 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                return -1;
              return 470; /* *vec_cmphev2df_cc */

            case E_V1TFmode:
              if (pattern274 (x7, 
E_V1TImode, 
E_V1TFmode) != 0
                  || !(
#line 2135 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 471; /* *vec_cmphev1tf_cc */

            case E_TFmode:
              if (pattern274 (x7, 
E_TImode, 
E_TFmode) != 0
                  || !(
#line 2135 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 472; /* *vec_cmphetf_cc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case USE:
      if (!memory_operand (operands[0], E_BLKmode)
          || !memory_operand (operands[1], E_BLKmode))
        return -1;
      x3 = XEXP (x2, 0);
      operands[2] = x3;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 1496 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCUmode)
   && INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 1774; /* *clc */

    default:
      return -1;
    }
}

 int
recog_114 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != MEM
      || pattern98 (x4) != 0)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x7) != USE)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 33
      || GET_MODE (x9) != E_CCmode)
    return -1;
  x10 = XEXP (x2, 0);
  operands[0] = x10;
  x11 = XEXP (x3, 0);
  operands[1] = x11;
  switch (pattern258 (x1))
    {
    case 0:
      if (!(
#line 3694 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return -1;
      return 1888; /* *cpymem_long */

    case 1:
      if (!(
#line 3694 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      return 1889; /* *cpymem_long */

    case 2:
      if (!
#line 3707 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
        return -1;
      return 1890; /* *cpymem_long_31z */

    default:
      return -1;
    }
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40;
  int res ATTRIBUTE_UNUSED;
  if (pattern6 (x1, 
39, 
E_TImode, 
17, 
38) != 0
      || pattern298 (x1, 
41, 
E_TImode, 
19, 
40, 
18) != 0
      || pattern299 (x1, 
43, 
E_TImode, 
21, 
42, 
20) != 0
      || pattern300 (x1, 
E_TImode, 
45, 
23, 
44, 
22) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 18);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 24
      || GET_MODE (x3) != E_TImode)
    return -1;
  x4 = XVECEXP (x1, 0, 19);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 46
      || GET_MODE (x5) != E_TImode)
    return -1;
  x6 = XVECEXP (x1, 0, 20);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 25
      || GET_MODE (x7) != E_TImode)
    return -1;
  x8 = XVECEXP (x1, 0, 21);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 47
      || GET_MODE (x9) != E_TImode)
    return -1;
  x10 = XVECEXP (x1, 0, 22);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 26
      || GET_MODE (x11) != E_TImode)
    return -1;
  x12 = XVECEXP (x1, 0, 23);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 48
      || GET_MODE (x13) != E_TImode)
    return -1;
  x14 = XVECEXP (x1, 0, 24);
  if (GET_CODE (x14) != CLOBBER)
    return -1;
  x15 = XEXP (x14, 0);
  if (GET_CODE (x15) != REG
      || REGNO (x15) != 27
      || GET_MODE (x15) != E_TImode)
    return -1;
  x16 = XVECEXP (x1, 0, 25);
  if (GET_CODE (x16) != CLOBBER)
    return -1;
  x17 = XEXP (x16, 0);
  if (GET_CODE (x17) != REG
      || REGNO (x17) != 49
      || GET_MODE (x17) != E_TImode)
    return -1;
  x18 = XVECEXP (x1, 0, 26);
  if (GET_CODE (x18) != CLOBBER)
    return -1;
  x19 = XEXP (x18, 0);
  if (GET_CODE (x19) != REG
      || REGNO (x19) != 28
      || GET_MODE (x19) != E_TImode)
    return -1;
  x20 = XVECEXP (x1, 0, 27);
  if (GET_CODE (x20) != CLOBBER)
    return -1;
  x21 = XEXP (x20, 0);
  if (GET_CODE (x21) != REG
      || REGNO (x21) != 50
      || GET_MODE (x21) != E_TImode)
    return -1;
  x22 = XVECEXP (x1, 0, 28);
  if (GET_CODE (x22) != CLOBBER)
    return -1;
  x23 = XEXP (x22, 0);
  if (GET_CODE (x23) != REG
      || REGNO (x23) != 29
      || GET_MODE (x23) != E_TImode)
    return -1;
  x24 = XVECEXP (x1, 0, 29);
  if (GET_CODE (x24) != CLOBBER)
    return -1;
  x25 = XEXP (x24, 0);
  if (GET_CODE (x25) != REG
      || REGNO (x25) != 51
      || GET_MODE (x25) != E_TImode)
    return -1;
  x26 = XVECEXP (x1, 0, 30);
  if (GET_CODE (x26) != CLOBBER)
    return -1;
  x27 = XEXP (x26, 0);
  if (GET_CODE (x27) != REG
      || REGNO (x27) != 30
      || GET_MODE (x27) != E_TImode)
    return -1;
  x28 = XVECEXP (x1, 0, 31);
  if (GET_CODE (x28) != CLOBBER)
    return -1;
  x29 = XEXP (x28, 0);
  if (GET_CODE (x29) != REG
      || REGNO (x29) != 52
      || GET_MODE (x29) != E_TImode)
    return -1;
  x30 = XVECEXP (x1, 0, 32);
  if (GET_CODE (x30) != CLOBBER)
    return -1;
  x31 = XEXP (x30, 0);
  if (GET_CODE (x31) != REG
      || REGNO (x31) != 31
      || GET_MODE (x31) != E_TImode)
    return -1;
  x32 = XVECEXP (x1, 0, 33);
  if (GET_CODE (x32) != CLOBBER)
    return -1;
  x33 = XEXP (x32, 0);
  if (GET_CODE (x33) != REG
      || REGNO (x33) != 53
      || GET_MODE (x33) != E_TImode)
    return -1;
  x34 = XVECEXP (x1, 0, 0);
  x35 = XEXP (x34, 1);
  x36 = XVECEXP (x35, 0, 0);
  operands[0] = x36;
  if (!const_int_operand (operands[0], E_VOIDmode))
    return -1;
  x37 = XVECEXP (x1, 0, 1);
  x38 = XEXP (x37, 0);
  operands[1] = x38;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x39 = XEXP (x37, 1);
  x40 = XVECEXP (x39, 0, 0);
  if (!rtx_equal_p (x40, operands[0])
      || !
#line 12380 "../../gcc/config/s390/s390.md"
(TARGET_VX && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
    return -1;
  return 2648; /* tbegin_1_z13 */
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case UNSPEC:
      return recog_62 (x1, insn, pnum_clobbers);

    case VEC_SELECT:
      return recog_58 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_57 (x1, insn, pnum_clobbers);

    case NOT:
      return recog_55 (x1, insn, pnum_clobbers);

    case COMPARE:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 33)
        return -1;
      return recog_27 (x1, insn, pnum_clobbers);

    case BSWAP:
      return recog_68 (x1, insn, pnum_clobbers);

    case VEC_CONCAT:
      return recog_76 (x1, insn, pnum_clobbers);

    case VEC_DUPLICATE:
      return recog_65 (x1, insn, pnum_clobbers);

    case DIV:
      return recog_71 (x1, insn, pnum_clobbers);

    case UDIV:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 1164 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 726; /* udivv4si3 */

        case 1:
          if (!
#line 1164 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 727; /* udivv2di3 */

        case 2:
          if (!
#line 1164 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 728; /* udivv1ti3 */

        case 3:
          if (!
#line 1164 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 729; /* udivti3 */

        default:
          return -1;
        }

    case MOD:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 1173 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 730; /* modv4si3 */

        case 1:
          if (!
#line 1173 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 731; /* modv2di3 */

        case 2:
          if (!
#line 1173 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 732; /* modv1ti3 */

        case 3:
          if (!
#line 1173 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 733; /* modti3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern1 (x1))
        {
        case 0:
          if (!
#line 1182 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 734; /* umodv4si3 */

        case 1:
          if (!
#line 1182 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 735; /* umodv2di3 */

        case 2:
          if (!
#line 1182 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 736; /* umodv1ti3 */

        case 3:
          if (!
#line 1182 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
            return -1;
          return 737; /* umodti3 */

        default:
          return -1;
        }

    case NEG:
      return recog_56 (x1, insn, pnum_clobbers);

    case ABS:
      return recog_59 (x1, insn, pnum_clobbers);

    case XOR:
      return recog_60 (x1, insn, pnum_clobbers);

    case CLZ:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 931; /* clzv1qi2 */

        case 1:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 932; /* clzv2qi2 */

        case 2:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 933; /* clzv4qi2 */

        case 3:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 934; /* clzv8qi2 */

        case 4:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 935; /* clzv16qi2 */

        case 5:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 936; /* clzv1hi2 */

        case 6:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 937; /* clzv2hi2 */

        case 7:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 938; /* clzv4hi2 */

        case 8:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 939; /* clzv8hi2 */

        case 9:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 940; /* clzv1si2 */

        case 10:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 941; /* clzv2si2 */

        case 11:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 942; /* clzv4si2 */

        case 12:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 943; /* clzv1di2 */

        case 13:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 944; /* clzv2di2 */

        case 14:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 945; /* clzv1sf2 */

        case 15:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 946; /* clzv2sf2 */

        case 16:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 947; /* clzv4sf2 */

        case 17:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 948; /* clzv1df2 */

        case 18:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 949; /* clzv2df2 */

        case 19:
          if (!
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 950; /* clzv1tf2 */

        case 20:
          if (!(
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 30 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 951; /* clzv1ti2 */

        case 21:
          if (!(
#line 1436 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 30 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 952; /* clzti2 */

        case 22:
          if (!
#line 9607 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
            return -1;
          return 2499; /* *clzg */

        default:
          return -1;
        }

    case CTZ:
      return recog_78 (x1, insn, pnum_clobbers);

    case ROTATE:
      return recog_66 (x1, insn, pnum_clobbers);

    case ASHIFT:
      return recog_63 (x1, insn, pnum_clobbers);

    case ASHIFTRT:
      return recog_61 (x1, insn, pnum_clobbers);

    case LSHIFTRT:
      return recog_64 (x1, insn, pnum_clobbers);

    case SMIN:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 1632 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1107; /* *sminv1qi3 */

        case 1:
          if (!
#line 1632 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1108; /* *sminv2qi3 */

        case 2:
          if (!
#line 1632 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1109; /* *sminv4qi3 */

        case 3:
          if (!
#line 1632 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1110; /* *sminv8qi3 */

        case 4:
          if (!
#line 1632 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1111; /* *sminv16qi3 */

        case 5:
          if (!
#line 1632 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1112; /* *sminv1hi3 */

        case 6:
          if (!
#line 1632 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1113; /* *sminv2hi3 */

        case 7:
          if (!
#line 1632 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1114; /* *sminv4hi3 */

        case 8:
          if (!
#line 1632 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1115; /* *sminv8hi3 */

        case 9:
          if (!
#line 1632 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1116; /* *sminv1si3 */

        case 10:
          if (!
#line 1632 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1117; /* *sminv2si3 */

        case 11:
          if (!
#line 1632 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1118; /* *sminv4si3 */

        case 12:
          if (!
#line 1632 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1119; /* *sminv1di3 */

        case 13:
          if (!
#line 1632 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1120; /* *sminv2di3 */

        case 14:
          if (!(
#line 1632 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1121; /* *sminv1ti3 */

        case 15:
          if (!(
#line 1632 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1122; /* *sminti3 */

        case 16:
          if (!
#line 2051 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1289; /* *sminv4sf3_vxe */

        case 17:
          if (
#line 2051 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1290; /* *sminv2df3_vxe */
          if (!
#line 2060 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return -1;
          return 1293; /* *sminv2df3_vx */

        case 18:
          if (!
#line 2051 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1291; /* *sminv1tf3_vxe */

        case 19:
          if (!
#line 2051 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1292; /* *smintf3_vxe */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 1657 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1123; /* *smaxv1qi3 */

        case 1:
          if (!
#line 1657 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1124; /* *smaxv2qi3 */

        case 2:
          if (!
#line 1657 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1125; /* *smaxv4qi3 */

        case 3:
          if (!
#line 1657 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1126; /* *smaxv8qi3 */

        case 4:
          if (!
#line 1657 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1127; /* *smaxv16qi3 */

        case 5:
          if (!
#line 1657 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1128; /* *smaxv1hi3 */

        case 6:
          if (!
#line 1657 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1129; /* *smaxv2hi3 */

        case 7:
          if (!
#line 1657 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1130; /* *smaxv4hi3 */

        case 8:
          if (!
#line 1657 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1131; /* *smaxv8hi3 */

        case 9:
          if (!
#line 1657 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1132; /* *smaxv1si3 */

        case 10:
          if (!
#line 1657 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1133; /* *smaxv2si3 */

        case 11:
          if (!
#line 1657 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1134; /* *smaxv4si3 */

        case 12:
          if (!
#line 1657 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1135; /* *smaxv1di3 */

        case 13:
          if (!
#line 1657 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1136; /* *smaxv2di3 */

        case 14:
          if (!(
#line 1657 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1137; /* *smaxv1ti3 */

        case 15:
          if (!(
#line 1657 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1138; /* *smaxti3 */

        case 16:
          if (!
#line 2015 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1284; /* *smaxv4sf3_vxe */

        case 17:
          if (
#line 2015 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return 1285; /* *smaxv2df3_vxe */
          if (!
#line 2024 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
            return -1;
          return 1288; /* *smaxv2df3_vx */

        case 18:
          if (!
#line 2015 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1286; /* *smaxv1tf3_vxe */

        case 19:
          if (!
#line 2015 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1287; /* *smaxtf3_vxe */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern4 (x1))
        {
        case 0:
          if (!
#line 1682 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1139; /* *uminv1qi3 */

        case 1:
          if (!
#line 1682 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1140; /* *uminv2qi3 */

        case 2:
          if (!
#line 1682 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1141; /* *uminv4qi3 */

        case 3:
          if (!
#line 1682 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1142; /* *uminv8qi3 */

        case 4:
          if (!
#line 1682 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1143; /* *uminv16qi3 */

        case 5:
          if (!
#line 1682 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1144; /* *uminv1hi3 */

        case 6:
          if (!
#line 1682 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1145; /* *uminv2hi3 */

        case 7:
          if (!
#line 1682 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1146; /* *uminv4hi3 */

        case 8:
          if (!
#line 1682 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1147; /* *uminv8hi3 */

        case 9:
          if (!
#line 1682 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1148; /* *uminv1si3 */

        case 10:
          if (!
#line 1682 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1149; /* *uminv2si3 */

        case 11:
          if (!
#line 1682 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1150; /* *uminv4si3 */

        case 12:
          if (!
#line 1682 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1151; /* *uminv1di3 */

        case 13:
          if (!
#line 1682 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1152; /* *uminv2di3 */

        case 14:
          if (!(
#line 1682 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1153; /* *uminv1ti3 */

        case 15:
          if (!(
#line 1682 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1154; /* *uminti3 */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern4 (x1))
        {
        case 0:
          if (!
#line 1707 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1155; /* *umaxv1qi3 */

        case 1:
          if (!
#line 1707 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1156; /* *umaxv2qi3 */

        case 2:
          if (!
#line 1707 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1157; /* *umaxv4qi3 */

        case 3:
          if (!
#line 1707 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1158; /* *umaxv8qi3 */

        case 4:
          if (!
#line 1707 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1159; /* *umaxv16qi3 */

        case 5:
          if (!
#line 1707 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1160; /* *umaxv1hi3 */

        case 6:
          if (!
#line 1707 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1161; /* *umaxv2hi3 */

        case 7:
          if (!
#line 1707 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1162; /* *umaxv4hi3 */

        case 8:
          if (!
#line 1707 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1163; /* *umaxv8hi3 */

        case 9:
          if (!
#line 1707 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1164; /* *umaxv1si3 */

        case 10:
          if (!
#line 1707 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1165; /* *umaxv2si3 */

        case 11:
          if (!
#line 1707 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1166; /* *umaxv4si3 */

        case 12:
          if (!
#line 1707 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1167; /* *umaxv1di3 */

        case 13:
          if (!
#line 1707 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1168; /* *umaxv2di3 */

        case 14:
          if (!(
#line 1707 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1169; /* *umaxv1ti3 */

        case 15:
          if (!(
#line 1707 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 1170; /* *umaxti3 */

        default:
          return -1;
        }

    case SQRT:
      return recog_72 (x1, insn, pnum_clobbers);

    case FMA:
      return recog_75 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_77 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      return recog_69 (x1, insn, pnum_clobbers);

    case FLOAT:
      return recog_74 (x1, insn, pnum_clobbers);

    case UNSIGNED_FLOAT:
      return recog_70 (x1, insn, pnum_clobbers);

    case FIX:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 3002 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1529; /* fix_truncv2dfv2di2 */

        case 1:
          if (!(
#line 3002 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 99 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
            return -1;
          return 1530; /* fix_truncv4sfv4si2 */

        default:
          return -1;
        }

    case UNSIGNED_FIX:
      switch (pattern5 (x1))
        {
        case 0:
          if (!
#line 3034 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1531; /* fixuns_truncv2dfv2di2 */

        case 1:
          if (!(
#line 3034 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 99 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
            return -1;
          return 1532; /* fixuns_truncv4sfv4si2 */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x4 = XEXP (x2, 2);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      operands[3] = x4;
      if (const_int_operand (operands[3], E_VOIDmode))
        {
          res = recog_34 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (pnum_clobbers == NULL
          || XWINT (x4, 0) != 0LL)
        return -1;
      switch (pattern34 (x1))
        {
        case 0:
          if (!(
#line 4411 "../../gcc/config/s390/s390.md"
(!TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1946; /* *pre_z10_extzvdi */

        case 1:
          if (!
#line 4411 "../../gcc/config/s390/s390.md"
(!TARGET_Z10))
            return -1;
          *pnum_clobbers = 1;
          return 1947; /* *pre_z10_extzvsi */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x2, 2);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern34 (x1))
        {
        case 0:
          if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1948; /* *pre_z10_extvdi */

        case 1:
          *pnum_clobbers = 1;
          return 1949; /* *pre_z10_extvsi */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x2) != E_SFmode)
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DFmode:
              if (!register_operand (operands[1], E_DFmode)
                  || !
#line 5697 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2090; /* truncdfsf2 */

            case E_TFmode:
              if (pnum_clobbers == NULL
                  || !register_operand (operands[1], E_TFmode)
                  || !
#line 5715 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2092; /* trunctfsf2_fpr */

            default:
              return -1;
            }

        case E_DFmode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DFmode)
              || GET_MODE (x2) != E_DFmode
              || !register_operand (operands[1], E_TFmode)
              || !
#line 5715 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2091; /* trunctfdf2_fpr */

        case E_SDmode:
          if (!register_operand (operands[0], E_SDmode)
              || GET_MODE (x2) != E_SDmode
              || !register_operand (operands[1], E_DDmode)
              || !
#line 5746 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          return 2094; /* truncddsd2 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      return recog_67 (x1, insn, pnum_clobbers);

    case CALL:
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != MEM
          || GET_MODE (x5) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x6 = XEXP (x2, 1);
      if (!const_int_operand (x6, E_VOIDmode))
        return -1;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case REG:
          if (REGNO (x7) != 1)
            return -1;
          operands[1] = x6;
          if (!
#line 10801 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)
   && GET_MODE (XEXP (XEXP (XEXP (PATTERN (insn), 1), 0), 0)) == Pmode))
            return -1;
          return 2564; /* *sibcall_value_br */

        case CONST:
        case SYMBOL_REF:
          operands[1] = x7;
          if (!bras_sym_operand (operands[1], E_VOIDmode))
            return -1;
          operands[2] = x6;
          if (
#line 10831 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn) && TARGET_SMALL_EXEC))
            return 2565; /* *sibcall_value_brc */
          if (!
#line 10840 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)))
            return -1;
          return 2566; /* *sibcall_value_brcl */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_73 (x1, insn, pnum_clobbers);

    case POPCOUNT:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 12106 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      *pnum_clobbers = 1;
      return 2636; /* *popcountdi_z15 */

    case COPYSIGN:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_TFmode:
          if (pattern0 (x2, 
E_TFmode) != 0
              || !(
#line 12273 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2641; /* copysigntf3_fpr */

        case E_FPRX2mode:
          if (pattern0 (x2, 
E_FPRX2mode) != 0
              || !(
#line 12273 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2642; /* copysignfprx23 */

        case E_DFmode:
          if (pattern0 (x2, 
E_DFmode) != 0
              || !
#line 12273 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2643; /* copysigndf3 */

        case E_SFmode:
          if (pattern0 (x2, 
E_SFmode) != 0
              || !
#line 12273 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          return 2644; /* copysignsf3 */

        case E_TDmode:
          if (pattern0 (x2, 
E_TDmode) != 0
              || !(
#line 12273 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2645; /* copysigntd3 */

        case E_DDmode:
          if (pattern0 (x2, 
E_DDmode) != 0
              || !(
#line 12273 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2646; /* copysigndd3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}
