/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 16
      || GET_MODE (x3) != E_CCRAWmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC_VOLATILE
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 17
      || GET_MODE (x6) != E_BLKmode)
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x7) != CLOBBER)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 16
      || GET_MODE (x8) != i2)
    return -1;
  x9 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != i4
      || GET_MODE (x10) != i2)
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x11) != CLOBBER)
    return -1;
  x12 = XEXP (x11, 0);
  if (GET_CODE (x12) != REG
      || REGNO (x12) != i3
      || GET_MODE (x12) != i2)
    return -1;
  x13 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x13) != CLOBBER)
    return -1;
  x14 = XEXP (x13, 0);
  if (GET_CODE (x14) != REG
      || REGNO (x14) != i1)
    return -1;
  return 0;
}

int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern19 (x3, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern19 (x3, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern19 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern19 (x3, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern19 (x3, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern19 (x3, 
E_TImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x3) != E_V1HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1QImode:
          if (!register_operand (operands[1], E_V1QImode)
              || !register_operand (operands[2], E_V1QImode))
            return -1;
          return 0;

        case E_V2QImode:
          if (!register_operand (operands[1], E_V2QImode)
              || !register_operand (operands[2], E_V2QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V2HImode:
      if (pattern16 (x3, 
E_V4QImode, 
E_V2HImode) != 0)
        return -1;
      return 2;

    case E_V4HImode:
      if (pattern16 (x3, 
E_V8QImode, 
E_V4HImode) != 0)
        return -1;
      return 3;

    case E_V8HImode:
      if (pattern16 (x3, 
E_V16QImode, 
E_V8HImode) != 0)
        return -1;
      return 4;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x3) != E_V1SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1HImode:
          if (!register_operand (operands[1], E_V1HImode)
              || !register_operand (operands[2], E_V1HImode))
            return -1;
          return 5;

        case E_V2HImode:
          if (!register_operand (operands[1], E_V2HImode)
              || !register_operand (operands[2], E_V2HImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_V2SImode:
      if (pattern16 (x3, 
E_V4HImode, 
E_V2SImode) != 0)
        return -1;
      return 7;

    case E_V4SImode:
      if (pattern16 (x3, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 8;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V1SImode:
          if (!register_operand (operands[1], E_V1SImode)
              || !register_operand (operands[2], E_V1SImode))
            return -1;
          return 9;

        case E_V2SImode:
          if (!register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V2SImode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_V2DImode:
      if (pattern16 (x3, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 11;

    case E_V1TImode:
      if (pattern16 (x3, 
E_V1DImode, 
E_V1TImode) != 0)
        return -1;
      return 12;

    case E_TImode:
      if (pattern16 (x3, 
E_V2DImode, 
E_TImode) != 0)
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern55 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!const_int_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern19 (x1, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern19 (x1, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern19 (x1, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern19 (x1, 
E_V2DImode) != 0)
        return -1;
      return 3;

    case E_V1TImode:
      if (pattern19 (x1, 
E_V1TImode) != 0)
        return -1;
      return 4;

    case E_TImode:
      if (pattern19 (x1, 
E_TImode) != 0)
        return -1;
      return 5;

    case E_V2DFmode:
      if (pattern19 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 6;

    case E_V4SFmode:
      if (pattern19 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 7;

    case E_V1TFmode:
      if (pattern19 (x1, 
E_V1TFmode) != 0)
        return -1;
      return 8;

    case E_TFmode:
      if (pattern19 (x1, 
E_TFmode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCUmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCUmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x3, 0);
  operands[0] = x7;
  if (!memory_operand (operands[0], E_BLKmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[1] = x8;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  return 0;
}

int
pattern82 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern88 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          return 1;

        case E_QImode:
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern97 (rtx x1, machine_mode i1, unsigned int i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern102 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 33
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS
      || GET_MODE (x3) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  if (!register_operand (operands[3], E_DImode))
    return -1;
  return 0;
}

int
pattern123 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[2], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_BLKmode)
    return -1;
  switch (GET_CODE (x3))
    {
    case MEM:
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 3
          || XINT (x5, 1) != 32)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_BLKmode)
        return -1;
      x7 = XVECEXP (x5, 0, 1);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_BLKmode)
        return -1;
      x8 = XVECEXP (x5, 0, 2);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 0
          || GET_MODE (x8) != E_SImode)
        return -1;
      x9 = XVECEXP (x1, 0, 0);
      x10 = XEXP (x9, 0);
      operands[2] = x10;
      x11 = XEXP (x2, 0);
      x12 = XEXP (x11, 0);
      operands[1] = x12;
      x13 = XEXP (x3, 0);
      operands[3] = x13;
      x14 = XEXP (x4, 0);
      operands[0] = x14;
      x15 = XEXP (x6, 0);
      if (!rtx_equal_p (x15, operands[1]))
        return -1;
      x16 = XEXP (x7, 0);
      if (!rtx_equal_p (x16, operands[3]))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_DImode:
          return pattern123 (x5, 
E_DImode); /* [-1, 0] */

        case E_SImode:
          if (pattern123 (x5, 
E_SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 6)
        return -1;
      x17 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x17) != SUBREG)
        return -1;
      x11 = XEXP (x2, 0);
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != SUBREG)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != USE)
        return -1;
      x9 = XVECEXP (x1, 0, 0);
      x10 = XEXP (x9, 0);
      operands[0] = x10;
      x18 = XEXP (x12, 0);
      operands[3] = x18;
      x14 = XEXP (x4, 0);
      operands[1] = x14;
      x19 = XEXP (x17, 0);
      if (!rtx_equal_p (x19, operands[3]))
        return -1;
      x20 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x20))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
        case PLUS:
          operands[2] = x20;
          switch (SUBREG_BYTE (x17))
            {
            case 8:
              if (pattern124 (x2, 
E_TImode, 
0, 
E_DImode) != 0)
                return -1;
              return 2;

            case 4:
              if (pattern124 (x2, 
E_DImode, 
0, 
E_SImode) != 0)
                return -1;
              return 3;

            case 12:
              if (pattern124 (x2, 
E_TImode, 
4, 
E_SImode) != 0)
                return -1;
              return 4;

            default:
              return -1;
            }

        case ZERO_EXTEND:
          x21 = XEXP (x20, 0);
          operands[2] = x21;
          if (!setmem_operand (operands[2], E_QImode))
            return -1;
          switch (SUBREG_BYTE (x17))
            {
            case 8:
              if (pattern125 (x2, 
E_TImode, 
0, 
E_DImode) != 0)
                return -1;
              return 5;

            case 4:
              if (pattern125 (x2, 
E_DImode, 
0, 
E_SImode) != 0)
                return -1;
              return 6;

            case 12:
              if (pattern125 (x2, 
E_TImode, 
4, 
E_SImode) != 0)
                return -1;
              return 7;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern170 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !nonmemory_operand (operands[2], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !nonmemory_operand (operands[2], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern179 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 2;

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x1) != E_FPRX2mode
          || !register_operand (operands[1], E_FPRX2mode))
        return -1;
      return 3;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 4;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[1]))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!s_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode
              || !immediate_operand (operands[1], E_DImode))
            return -1;
          return 0;

        case E_SImode:
          if (!s_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || !immediate_operand (operands[1], E_SImode))
            return -1;
          return 1;

        case E_HImode:
          if (!s_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || !immediate_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case SUBREG:
    case MEM:
      if (!memory_operand (operands[1], E_VOIDmode)
          || !memory_operand (operands[0], E_VOIDmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern216 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern215 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern215 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern225 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  operands[3] = x1;
  if (!const0_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern234 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode)
          || !scratch_operand (operands[2], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode)
          || !scratch_operand (operands[2], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode)
          || !scratch_operand (operands[2], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode)
          || !scratch_operand (operands[2], E_V2DImode))
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode)
          || !scratch_operand (operands[2], E_V1TImode))
        return -1;
      return 4;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !scratch_operand (operands[2], E_TImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern263 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern272 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  if (!bras_sym_operand (operands[0], E_VOIDmode))
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!const_int_operand (operands[3], E_VOIDmode))
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!const_int_operand (operands[4], E_VOIDmode))
    return -1;
  x12 = XEXP (x2, 0);
  switch (GET_MODE (x12))
    {
    case E_DImode:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x13 = XVECEXP (x3, 0, 1);
      if (GET_MODE (x13) != E_DImode)
        return -1;
      return 0;

    case E_SImode:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x13 = XVECEXP (x3, 0, 1);
      if (GET_MODE (x13) != E_SImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern292 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern300 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 13);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 14);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 15);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 16);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i1)
    return -1;
  x10 = XVECEXP (x1, 0, 17);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i2
      || GET_MODE (x11) != i1)
    return -1;
  return 0;
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1185; /* vec_widen_umult_even_v1qi */

    case 1:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1186; /* vec_widen_umult_even_v2qi */

    case 2:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1187; /* vec_widen_umult_even_v4qi */

    case 3:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1188; /* vec_widen_umult_even_v8qi */

    case 4:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1189; /* vec_widen_umult_even_v16qi */

    case 5:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1190; /* vec_widen_umult_even_v1hi */

    case 6:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1191; /* vec_widen_umult_even_v2hi */

    case 7:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1192; /* vec_widen_umult_even_v4hi */

    case 8:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1193; /* vec_widen_umult_even_v8hi */

    case 9:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1194; /* vec_widen_umult_even_v1si */

    case 10:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1195; /* vec_widen_umult_even_v2si */

    case 11:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1196; /* vec_widen_umult_even_v4si */

    case 12:
      if (!
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1197; /* vec_widen_umult_even_v1di */

    case 13:
      if (!(
#line 1727 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 71 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 1198; /* vec_widen_umult_even_v2di */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 63:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_mask_operand (operands[2], E_QImode)
          || !
#line 201 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[2]) < 7))
        return -1;
      return 16; /* vlbb */

    case 65:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      if (!memory_operand (operands[2], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!nonmemory_operand (operands[1], E_SImode)
          || !
#line 227 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
        return -1;
      return 17; /* *vlrlrv16qi */

    case 66:
      switch (pattern17 (x1))
        {
        case 0:
          if (!
#line 266 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 18; /* vec_packv8hi */

        case 1:
          if (!
#line 266 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 19; /* vec_packv4si */

        case 2:
          if (!
#line 266 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 20; /* vec_packv2di */

        default:
          return -1;
        }

    case 67:
      switch (pattern17 (x1))
        {
        case 0:
          if (!
#line 279 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 21; /* vec_packsv8hi */

        case 1:
          if (!
#line 279 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 22; /* vec_packsv4si */

        case 2:
          if (!
#line 279 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 23; /* vec_packsv2di */

        default:
          return -1;
        }

    case 70:
      switch (pattern17 (x1))
        {
        case 0:
          if (!
#line 325 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 27; /* vec_packsuv8hi */

        case 1:
          if (!
#line 325 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 28; /* vec_packsuv4si */

        case 2:
          if (!
#line 325 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 29; /* vec_packsuv2di */

        default:
          return -1;
        }

    case 75:
      return recog_2 (x1, insn, pnum_clobbers);

    case 76:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[2] = x3;
      if (!memory_operand (operands[2], E_BLKmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!nonmemory_operand (operands[1], E_SImode)
          || !
#line 593 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
        return -1;
      return 92; /* *vstrlrv16qi */

    case 77:
      if (pattern18 (x1, 
E_V16QImode, 
E_V2DImode) != 0
          || !
#line 609 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE))
        return -1;
      return 93; /* vbpermv16qi */

    case 82:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 110; /* vaccb_v16qi */

        case 1:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 111; /* vacch_v8hi */

        case 2:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 112; /* vaccf_v4si */

        case 3:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 113; /* vaccg_v2di */

        case 4:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 114; /* vaccq_v1ti */

        case 5:
          if (!
#line 665 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 115; /* vaccq_ti */

        default:
          return -1;
        }

    case 85:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 127; /* vec_avgv16qi */

        case 1:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 128; /* vec_avgv8hi */

        case 2:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 129; /* vec_avgv4si */

        case 3:
          if (!
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 130; /* vec_avgv2di */

        case 4:
          if (!(
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 131; /* vec_avgv1ti */

        case 5:
          if (!(
#line 717 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 132; /* vec_avgti */

        default:
          return -1;
        }

    case 86:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 133; /* vec_avguv16qi */

        case 1:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 134; /* vec_avguv8hi */

        case 2:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 135; /* vec_avguv4si */

        case 3:
          if (!
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 136; /* vec_avguv2di */

        case 4:
          if (!(
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 137; /* vec_avguv1ti */

        case 5:
          if (!(
#line 729 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 51 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 138; /* vec_avguti */

        default:
          return -1;
        }

    case 87:
      if (pattern21 (x1, 
E_V4SImode) != 0
          || !
#line 741 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 139; /* vec_checksum */

    case 88:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern19 (x2, 
E_V16QImode) != 0
              || !
#line 850 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 140; /* vec_gfmsumv16qi */

        case E_V8HImode:
          if (pattern19 (x2, 
E_V8HImode) != 0
              || !
#line 850 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 141; /* vec_gfmsumv8hi */

        case E_V4SImode:
          if (pattern19 (x2, 
E_V4SImode) != 0
              || !
#line 850 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 142; /* vec_gfmsumv4si */

        default:
          return -1;
        }

    case 89:
      if (pattern18 (x1, 
E_V2DImode, 
E_V16QImode) != 0
          || !
#line 859 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 143; /* vec_gfmsum_128 */

    case 47:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 182; /* vec_smulhv16qi */

        case 1:
          if (!
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 183; /* vec_smulhv8hi */

        case 2:
          if (!
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 184; /* vec_smulhv4si */

        case 3:
          if (!(
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 185; /* vec_smulhv2di */

        case 4:
          if (!(
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 186; /* vec_smulhv1ti */

        case 5:
          if (!(
#line 989 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 187; /* vec_smulhti */

        default:
          return -1;
        }

    case 48:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 188; /* vec_umulhv16qi */

        case 1:
          if (!
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 189; /* vec_umulhv8hi */

        case 2:
          if (!
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 190; /* vec_umulhv4si */

        case 3:
          if (!(
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 191; /* vec_umulhv2di */

        case 4:
          if (!(
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 192; /* vec_umulhv1ti */

        case 5:
          if (!(
#line 999 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 52 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
            return -1;
          return 193; /* vec_umulhti */

        default:
          return -1;
        }

    case 97:
      return recog_6 (x1, insn, pnum_clobbers);

    case 102:
      return recog_5 (x1, insn, pnum_clobbers);

    case 103:
      switch (pattern24 (x1))
        {
        case 0:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 297; /* vec_srabv16qi */

        case 1:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 298; /* vec_srabv8hi */

        case 2:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 299; /* vec_srabv4si */

        case 3:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 300; /* vec_srabv2di */

        case 4:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 301; /* vec_srabv1ti */

        case 5:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 302; /* vec_srabti */

        case 6:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 303; /* vec_srabv4sf */

        case 7:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 304; /* vec_srabv2df */

        case 8:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 305; /* vec_srabv1tf */

        case 9:
          if (!
#line 1130 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 306; /* vec_srabtf */

        default:
          return -1;
        }

    case 104:
      return recog_4 (x1, insn, pnum_clobbers);

    case 106:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 1167 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 337; /* vscbib_v16qi */

        case 1:
          if (!
#line 1167 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 338; /* vscbih_v8hi */

        case 2:
          if (!
#line 1167 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 339; /* vscbif_v4si */

        case 3:
          if (!
#line 1167 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 340; /* vscbig_v2di */

        case 4:
          if (!
#line 1167 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 341; /* vscbiq_v1ti */

        case 5:
          if (!
#line 1167 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 342; /* vscbiq_ti */

        default:
          return -1;
        }

    case 94:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !register_operand (operands[2], E_V4SImode)
              || !
#line 1215 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 345; /* vec_sum_u128v4si */

        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !register_operand (operands[2], E_V2DImode)
              || !
#line 1215 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 346; /* vec_sum_u128v2di */

        default:
          return -1;
        }

    case 109:
      return recog_3 (x1, insn, pnum_clobbers);

    case 130:
      return recog_12 (x1, insn, pnum_clobbers);

    case 138:
      if (pattern26 (x1, 
3, 
2, 
1, 
0) != 0
          || !
#line 2224 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 501; /* vclfnhs_v8hi */

    case 139:
      if (pattern26 (x1, 
7, 
6, 
5, 
4) != 0
          || !
#line 2235 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 502; /* vclfnls_v8hi */

    case 141:
      if (pattern27 (x1) != 0
          || !
#line 2254 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 504; /* vcfn_v8hi */

    case 142:
      if (pattern27 (x1) != 0
          || !
#line 2263 "../../gcc/config/s390/vx-builtins.md"
(TARGET_NNPA))
        return -1;
      return 505; /* vcnf_v8hi */

    case 93:
      if (GET_MODE (x2) != E_V2DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !
#line 1232 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 768; /* *vec_sum2v8hi */

        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !register_operand (operands[2], E_V4SImode)
              || !
#line 1232 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 769; /* *vec_sum2v4si */

        default:
          return -1;
        }

    case 95:
      if (GET_MODE (x2) != E_V4SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !register_operand (operands[2], E_V16QImode)
              || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 770; /* *vec_sum4v16qi */

        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !register_operand (operands[2], E_V8HImode)
              || !
#line 1242 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 771; /* *vec_sum4v8hi */

        default:
          return -1;
        }

    case 105:
      switch (pattern24 (x1))
        {
        case 0:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1087; /* *vec_srbv16qi */

        case 1:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1088; /* *vec_srbv8hi */

        case 2:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1089; /* *vec_srbv4si */

        case 3:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1090; /* *vec_srbv2di */

        case 4:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1091; /* *vec_srbv1ti */

        case 5:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1092; /* *vec_srbti */

        case 6:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1093; /* *vec_srbv4sf */

        case 7:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1094; /* *vec_srbv2df */

        case 8:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1095; /* *vec_srbv1tf */

        case 9:
          if (!
#line 1578 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1096; /* *vec_srbtf */

        default:
          return -1;
        }

    case 98:
      return recog_13 (x1, insn, pnum_clobbers);

    case 50:
      return recog_11 (x1, insn, pnum_clobbers);

    case 51:
      return recog_10 (x1, insn, pnum_clobbers);

    case 52:
      return recog_9 (x1, insn, pnum_clobbers);

    case 53:
      return recog_8 (x1, insn, pnum_clobbers);

    case 64:
      if (GET_MODE (x2) != E_V16QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!memory_operand (operands[2], E_BLKmode)
          || !
#line 2427 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1406; /* vllv16qi */

    case 3:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 0
          || GET_MODE (x5) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode)
          || !
#line 3734 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
        return -1;
      return 1891; /* *mvcrl */

    case 36:
      return recog_7 (x1, insn, pnum_clobbers);

    case 1:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!s_operand (operands[1], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          *pnum_clobbers = 1;
          return 1917; /* *sethighpartsi */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode)
            return -1;
          if (
#line 4260 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            {
              *pnum_clobbers = 1;
              return 1918; /* *sethighpartdi_64 */
            }
          if (!
#line 4270 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1919; /* *sethighpartdi_31 */

        default:
          return -1;
        }

    case 38:
      if (pattern21 (x1, 
E_DImode) != 0
          || !
#line 4946 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
        return -1;
      return 2006; /* bdepg */

    case 39:
      if (pattern21 (x1, 
E_DImode) != 0
          || !
#line 4959 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
        return -1;
      return 2007; /* bextg */

    case 29:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !memory_operand (operands[1], E_DImode)
              || !
#line 11090 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          return 2581; /* *tls_load_64 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !memory_operand (operands[1], E_SImode)
              || !
#line 11100 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          return 2582; /* *tls_load_31 */

        default:
          return -1;
        }

    case 34:
      if (pattern25 (x1, 
E_CCZmode) != 0)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!memory_operand (operands[0], E_DImode)
              || !memory_operand (operands[1], E_DImode))
            return -1;
          return 2625; /* stack_protect_testdi */

        case E_SImode:
          if (!memory_operand (operands[0], E_SImode)
              || !memory_operand (operands[1], E_SImode))
            return -1;
          return 2626; /* stack_protect_testsi */

        default:
          return -1;
        }

    case 2:
      if (GET_MODE (x2) != E_BLKmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[0]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          return 2627; /* stack_tiedi */

        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          return 2628; /* stack_tiesi */

        default:
          return -1;
        }

    case 46:
      if (pnum_clobbers == NULL
          || GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!address_operand (operands[1], E_VOIDmode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!immediate_operand (operands[2], E_SImode)
          || !
#line 12550 "../../gcc/config/s390/s390.md"
(TARGET_Z13))
        return -1;
      *pnum_clobbers = 1;
      return 2660; /* lcbb */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[1] = x3;
  if (const_int_operand (operands[1], E_VOIDmode))
    {
      res = recog_42 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x5 = XEXP (x1, 1);
  if (!const_int_operand (x5, E_DImode))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 16LL:
      x6 = XEXP (x2, 2);
      operands[1] = x6;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      operands[2] = x5;
      if (!
#line 4897 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && EXTRACT_ARGS_IN_RANGE (16, INTVAL (operands[1]), 64)
   && INTVAL (operands[1]) >= 0
   && INTVAL (operands[1]) < BITS_PER_WORD
   && INTVAL (operands[1]) % 16 == 0))
        return -1;
      return 2003; /* *insvdi_reg_imm */

    case 32LL:
      x6 = XEXP (x2, 2);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[1] = x5;
      switch (XWINT (x6, 0))
        {
        case 0LL:
          if (!
#line 4921 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
            return -1;
          return 2004; /* *insv_h_di_reg_extimm */

        case 32LL:
          if (!
#line 4932 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
            return -1;
          return 2005; /* *insv_l_di_reg_extimm */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 2638 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1502; /* zero_extendv2qiv2hi2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 2638 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1504; /* zero_extendv2hiv2si2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 2638 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1506; /* zero_extendv2siv2di2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 2638 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1508; /* zero_extendv4qiv4hi2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 2638 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1510; /* zero_extendv4hiv4si2 */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !memory_operand (operands[1], E_QImode))
            return -1;
          if (
#line 5329 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM))
            return 2036; /* *zero_extendqihi2_64 */
          if (!
#line 5337 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2037; /* *zero_extendqihi2_31 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern114 (x3))
        {
        case 0:
          if (!
#line 2694 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1513; /* vec_unpacku_hi_v16qi */

        case 1:
          if (!
#line 2705 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1514; /* vec_unpacku_lo_v16qi */

        case 2:
          if (!
#line 2741 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1517; /* vec_unpacku_hi_v8hi */

        case 3:
          if (!
#line 2751 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1518; /* vec_unpacku_lo_v8hi */

        case 4:
          if (!
#line 2787 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1521; /* vec_unpacku_hi_v4si */

        case 5:
          if (!
#line 2797 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1522; /* vec_unpacku_lo_v4si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_54 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case GTU:
      res = recog_38 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      res = recog_53 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      if (s390_alc_comparison (operands[1], E_DImode)
          && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        {
          *pnum_clobbers = 1;
          return 2298; /* *sconddi */
        }
      if (!s390_slb_comparison (operands[1], E_DImode)
          || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2300; /* *sconddi_neg */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      if (s390_alc_comparison (operands[1], E_SImode))
        {
          *pnum_clobbers = 1;
          return 2299; /* *scondsi */
        }
      if (!s390_slb_comparison (operands[1], E_SImode))
        return -1;
      *pnum_clobbers = 1;
      return 2301; /* *scondsi_neg */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (!register_operand (operands[0], E_V1QImode)
              || GET_MODE (x3) != E_V1QImode
              || !register_operand (operands[1], E_V1QImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 738; /* negv1qi2 */

        case E_V2QImode:
          if (!register_operand (operands[0], E_V2QImode)
              || GET_MODE (x3) != E_V2QImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 739; /* negv2qi2 */

        case E_V4QImode:
          if (!register_operand (operands[0], E_V4QImode)
              || GET_MODE (x3) != E_V4QImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 740; /* negv4qi2 */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 741; /* negv8qi2 */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 742; /* negv16qi2 */

        case E_V1HImode:
          if (!register_operand (operands[0], E_V1HImode)
              || GET_MODE (x3) != E_V1HImode
              || !register_operand (operands[1], E_V1HImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 743; /* negv1hi2 */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 744; /* negv2hi2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 745; /* negv4hi2 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 746; /* negv8hi2 */

        case E_V1SImode:
          if (!register_operand (operands[0], E_V1SImode)
              || GET_MODE (x3) != E_V1SImode
              || !register_operand (operands[1], E_V1SImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 747; /* negv1si2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 748; /* negv2si2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 749; /* negv4si2 */

        case E_V1DImode:
          if (!register_operand (operands[0], E_V1DImode)
              || GET_MODE (x3) != E_V1DImode
              || !register_operand (operands[1], E_V1DImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 750; /* negv1di2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1190 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 751; /* negv2di2 */

        case E_V1SFmode:
          if (!register_operand (operands[0], E_V1SFmode)
              || GET_MODE (x3) != E_V1SFmode
              || !register_operand (operands[1], E_V1SFmode)
              || !(
#line 1972 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1263; /* negv1sf2 */

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !(
#line 1972 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1264; /* negv2sf2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !(
#line 1972 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1265; /* negv4sf2 */

        case E_V1DFmode:
          if (!register_operand (operands[0], E_V1DFmode)
              || GET_MODE (x3) != E_V1DFmode
              || !register_operand (operands[1], E_V1DFmode)
              || !
#line 1972 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1266; /* negv1df2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 1972 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1267; /* negv2df2 */

        case E_V1TFmode:
          if (!register_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !register_operand (operands[1], E_V1TFmode)
              || !(
#line 1972 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1268; /* negv1tf2 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode
              || !register_operand (operands[1], E_TFmode))
            return -1;
          if ((
#line 1972 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1269; /* negtf2_vr */
          if ((
#line 9252 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return 2433; /* *negtf2_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9264 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2439; /* *negtf2 */

        case E_DImode:
          if (pattern83 (x3, pnum_clobbers, 
E_DImode) != 0)
            return -1;
          if (
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            {
              *pnum_clobbers = 1;
              return 2422; /* *negdi2 */
            }
          if (!
#line 9141 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2424; /* *negdi2_31 */

        case E_SImode:
          if (pattern83 (x3, pnum_clobbers, 
E_SImode) != 0)
            return -1;
          *pnum_clobbers = 1;
          return 2423; /* *negsi2 */

        case E_FPRX2mode:
          if (!register_operand (operands[0], E_FPRX2mode)
              || GET_MODE (x3) != E_FPRX2mode
              || !register_operand (operands[1], E_FPRX2mode))
            return -1;
          if ((
#line 9252 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return 2434; /* *negfprx22_nocc */
          if (pnum_clobbers == NULL
              || !(
#line 9264 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2440; /* *negfprx22 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode))
            return -1;
          if (
#line 9252 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2435; /* *negdf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9264 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2441; /* *negdf2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode))
            return -1;
          if (
#line 9252 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
            return 2436; /* *negsf2_nocc */
          if (pnum_clobbers == NULL
              || !
#line 9264 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2442; /* *negsf2 */

        case E_TDmode:
          if (!register_operand (operands[0], E_TDmode)
              || GET_MODE (x3) != E_TDmode
              || !register_operand (operands[1], E_TDmode)
              || !(
#line 9252 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2437; /* *negtd2_nocc */

        case E_DDmode:
          if (!register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_DDmode)
              || !(
#line 9252 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2438; /* *negdd2_nocc */

        default:
          return -1;
        }

    case FMA:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x4, 2);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern156 (x3, 
E_V4SFmode) != 0
                  || !(
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V4SFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1255; /* neg_fmav4sf4 */

            case E_V2DFmode:
              if (pattern156 (x3, 
E_V2DFmode) != 0
                  || !
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V2DFmode)))
                return -1;
              return 1256; /* neg_fmav2df4 */

            case E_V1TFmode:
              if (pattern156 (x3, 
E_V1TFmode) != 0
                  || !(
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V1TFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1257; /* neg_fmav1tf4 */

            case E_TFmode:
              if (pattern156 (x3, 
E_TFmode) != 0
                  || !(
#line 1953 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (TFmode)) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1258; /* neg_fmatf4 */

            default:
              return -1;
            }

        case NEG:
          x8 = XEXP (x7, 0);
          operands[3] = x8;
          switch (GET_MODE (operands[0]))
            {
            case E_V4SFmode:
              if (pattern157 (x3, 
E_V4SFmode) != 0
                  || !(
#line 1964 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V4SFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1259; /* neg_fmsv4sf4 */

            case E_V2DFmode:
              if (pattern157 (x3, 
E_V2DFmode) != 0
                  || !
#line 1964 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V2DFmode)))
                return -1;
              return 1260; /* neg_fmsv2df4 */

            case E_V1TFmode:
              if (pattern157 (x3, 
E_V1TFmode) != 0
                  || !(
#line 1964 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (V1TFmode)) && 
#line 87 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1261; /* neg_fmsv1tf4 */

            case E_TFmode:
              if (pattern157 (x3, 
E_TFmode) != 0
                  || !(
#line 1964 "../../gcc/config/s390/vector.md"
(TARGET_VXE && s390_fma_allowed_p (TFmode)) && 
#line 88 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1262; /* neg_fmstf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V1SFmode:
              if (pattern109 (x3, 
E_V1SFmode) != 0
                  || !(
#line 2000 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1277; /* negabsv1sf2 */

            case E_V2SFmode:
              if (pattern109 (x3, 
E_V2SFmode) != 0
                  || !(
#line 2000 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1278; /* negabsv2sf2 */

            case E_V4SFmode:
              if (pattern109 (x3, 
E_V4SFmode) != 0
                  || !(
#line 2000 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1279; /* negabsv4sf2 */

            case E_V1DFmode:
              if (pattern109 (x3, 
E_V1DFmode) != 0
                  || !
#line 2000 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1280; /* negabsv1df2 */

            case E_V2DFmode:
              if (pattern109 (x3, 
E_V2DFmode) != 0
                  || !
#line 2000 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return -1;
              return 1281; /* negabsv2df2 */

            case E_V1TFmode:
              if (pattern109 (x3, 
E_V1TFmode) != 0
                  || !(
#line 2000 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return -1;
              return 1282; /* negabsv1tf2 */

            case E_TFmode:
              if (pattern109 (x3, 
E_TFmode) != 0)
                return -1;
              if ((
#line 2000 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1283; /* negabstf2 */
              if ((
#line 9516 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return 2485; /* *negabstf2_nocc */
              if (pnum_clobbers == NULL
                  || !(
#line 9527 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2491; /* *negabstf2 */

            case E_DImode:
              if (pnum_clobbers == NULL
                  || pattern109 (x3, 
E_DImode) != 0
                  || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 2475; /* *negabsdi2 */

            case E_SImode:
              if (pnum_clobbers == NULL
                  || pattern109 (x3, 
E_SImode) != 0)
                return -1;
              *pnum_clobbers = 1;
              return 2476; /* *negabssi2 */

            case E_FPRX2mode:
              if (pattern109 (x3, 
E_FPRX2mode) != 0)
                return -1;
              if ((
#line 9516 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return 2486; /* *negabsfprx22_nocc */
              if (pnum_clobbers == NULL
                  || !(
#line 9527 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              *pnum_clobbers = 1;
              return 2492; /* *negabsfprx22 */

            case E_DFmode:
              if (pattern109 (x3, 
E_DFmode) != 0)
                return -1;
              if (
#line 9516 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
                return 2487; /* *negabsdf2_nocc */
              if (pnum_clobbers == NULL
                  || !
#line 9527 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2493; /* *negabsdf2 */

            case E_SFmode:
              if (pattern109 (x3, 
E_SFmode) != 0)
                return -1;
              if (
#line 9516 "../../gcc/config/s390/s390.md"
(TARGET_DFP))
                return 2488; /* *negabssf2_nocc */
              if (pnum_clobbers == NULL
                  || !
#line 9527 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              *pnum_clobbers = 1;
              return 2494; /* *negabssf2 */

            case E_TDmode:
              if (pattern109 (x3, 
E_TDmode) != 0
                  || !(
#line 9516 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2489; /* *negabstd2_nocc */

            case E_DDmode:
              if (pattern109 (x3, 
E_DDmode) != 0
                  || !(
#line 9516 "../../gcc/config/s390/s390.md"
(TARGET_DFP) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2490; /* *negabsdd2_nocc */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pnum_clobbers == NULL
              || GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x9 = XEXP (x5, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 9447 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2470; /* *negabsdi2_sign */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pnum_clobbers == NULL
          || pattern66 (x3, 
E_SImode) != 0
          || !
#line 9099 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2417; /* *negdi2_sign */

    default:
      return -1;
    }
}

 int
recog_70 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 2972 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1527; /* floatunsv2div2df2 */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode)
          || !(
#line 2972 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 99 "../../gcc/config/s390/vector.md"
(TARGET_VXE2)))
        return -1;
      return 1528; /* floatunsv4siv4sf2 */

    case E_DFmode:
      switch (pattern67 (x3, 
E_DFmode))
        {
        case 0:
          if (
#line 5667 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT))
            return 2076; /* *floatunsdidf2_z13 */
          if (!(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DFmode != DFmode || DImode != DImode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2082; /* *floatunsdidf2 */

        case 1:
          if (!
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DFmode != DFmode || SImode != DImode)))
            return -1;
          return 2083; /* *floatunssidf2 */

        default:
          return -1;
        }

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          if ((
#line 5667 "../../gcc/config/s390/s390.md"
(TARGET_VX && TARGET_HARD_FLOAT) && 
#line 767 "../../gcc/config/s390/s390.md"
(TARGET_VXE2)))
            return 2077; /* *floatunssisf2_z13 */
          if (!
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || SFmode != DFmode || SImode != DImode)))
            return -1;
          return 2085; /* *floatunssisf2 */

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || SFmode != DFmode || DImode != DImode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2084; /* *floatunsdisf2 */

        default:
          return -1;
        }

    case E_TFmode:
      switch (pattern67 (x3, 
E_TFmode))
        {
        case 0:
          if (!(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TFmode != DFmode || DImode != DImode)) && (
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2078; /* *floatunsditf2 */

        case 1:
          if (!(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TFmode != DFmode || SImode != DImode)) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2079; /* *floatunssitf2 */

        default:
          return -1;
        }

    case E_FPRX2mode:
      switch (pattern67 (x3, 
E_FPRX2mode))
        {
        case 0:
          if (!(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || FPRX2mode != DFmode || DImode != DImode)) && (
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2080; /* *floatunsdifprx22 */

        case 1:
          if (!(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || FPRX2mode != DFmode || SImode != DImode)) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2081; /* *floatunssifprx22 */

        default:
          return -1;
        }

    case E_TDmode:
      switch (pattern67 (x3, 
E_TDmode))
        {
        case 0:
          if (!(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TDmode != DFmode || DImode != DImode)) && (
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2086; /* *floatunsditd2 */

        case 1:
          if (!(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || TDmode != DFmode || SImode != DImode)) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2087; /* *floatunssitd2 */

        default:
          return -1;
        }

    case E_DDmode:
      switch (pattern67 (x3, 
E_DDmode))
        {
        case 0:
          if (!(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DDmode != DFmode || DImode != DImode)) && (
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))))
            return -1;
          return 2088; /* *floatunsdidd2 */

        case 1:
          if (!(
#line 5679 "../../gcc/config/s390/s390.md"
(TARGET_Z196 && TARGET_HARD_FLOAT
   && (!TARGET_VX || DDmode != DFmode || SImode != DImode)) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          return 2089; /* *floatunssidd2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_80 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
    case MEM:
      return recog_79 (x1, insn, pnum_clobbers);

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      x5 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x5))
        {
        case SET:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          x7 = XEXP (x5, 1);
          if (!rtx_equal_p (x7, operands[0]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (!const0_operand (operands[1], E_DImode)
                  || !register_operand (operands[2], E_DImode))
                return -1;
              if (nonimmediate_operand (operands[0], E_DImode)
                  && (
#line 1094 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1739; /* *tstdi_extimm */
              if (!register_operand (operands[0], E_DImode)
                  || !
#line 1136 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_ZARCH && !TARGET_EXTIMM))
                return -1;
              return 1743; /* *tstdi */

            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode)
                  || !const0_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode))
                return -1;
              if (
#line 1094 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM))
                return 1740; /* *tstsi_extimm */
              if (!
#line 1147 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && !TARGET_EXTIMM))
                return -1;
              return 1744; /* *tstsi */

            case E_HImode:
              if (!const0_operand (operands[1], E_HImode)
                  || !register_operand (operands[2], E_HImode))
                return -1;
              if (nonimmediate_operand (operands[0], E_HImode)
                  && 
#line 1197 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return 1749; /* *tsthiCCT */
              if (!s_operand (operands[0], E_HImode)
                  || !
#line 1239 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return -1;
              return 1753; /* *tsthi */

            case E_QImode:
              if (!const0_operand (operands[1], E_QImode)
                  || !register_operand (operands[2], E_QImode))
                return -1;
              if (nonimmediate_operand (operands[0], E_QImode)
                  && 
#line 1197 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                return 1750; /* *tstqiCCT */
              if (!s_operand (operands[0], E_QImode)
                  || !
#line 1239 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return -1;
              return 1754; /* *tstqi */

            default:
              return -1;
            }

        case CLOBBER:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && const0_operand (operands[1], E_DImode)
                  && scratch_operand (operands[2], E_DImode)
                  && (
#line 1123 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 1741; /* *tstdi_cconly_extimm */
              break;

            case E_SImode:
              if (nonimmediate_operand (operands[0], E_SImode)
                  && const0_operand (operands[1], E_SImode)
                  && scratch_operand (operands[2], E_SImode))
                {
                  if (
#line 1123 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode) && TARGET_EXTIMM))
                    return 1742; /* *tstsi_cconly_extimm */
                  if (
#line 1161 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                    return 1745; /* *tstsi_cconly */
                }
              break;

            case E_HImode:
              if (const0_operand (operands[1], E_HImode)
                  && scratch_operand (operands[2], E_HImode))
                {
                  if (nonimmediate_operand (operands[0], E_HImode)
                      && 
#line 1211 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCTmode)))
                    return 1751; /* *tsthiCCT_cconly */
                  if (s_operand (operands[0], E_HImode)
                      && 
#line 1252 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                    return 1755; /* *tsthi_cconly */
                }
              break;

            case E_QImode:
              if (s_operand (operands[0], E_QImode)
                  && const0_operand (operands[1], E_QImode)
                  && scratch_operand (operands[2], E_QImode)
                  && 
#line 1252 "../../gcc/config/s390/s390.md"
(s390_match_ccmode(insn, CCSmode)))
                return 1756; /* *tstqi_cconly */
              break;

            default:
              break;
            }
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CCZmode
              || GET_MODE (x3) != E_CCZmode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || !const0_operand (operands[1], E_TFmode)
                  || !register_operand (operands[2], E_TFmode)
                  || !(
#line 1558 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 1775; /* *cmptf_ccz_0 */

            case E_FPRX2mode:
              if (!register_operand (operands[0], E_FPRX2mode)
                  || !const0_operand (operands[1], E_FPRX2mode)
                  || !register_operand (operands[2], E_FPRX2mode)
                  || !(
#line 1558 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 1776; /* *cmpfprx2_ccz_0 */

            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || !const0_operand (operands[1], E_DFmode)
                  || !register_operand (operands[2], E_DFmode)
                  || !
#line 1558 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1777; /* *cmpdf_ccz_0 */

            case E_SFmode:
              if (!register_operand (operands[0], E_SFmode)
                  || !const0_operand (operands[1], E_SFmode)
                  || !register_operand (operands[2], E_SFmode)
                  || !
#line 1558 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 1778; /* *cmpsf_ccz_0 */

            case E_TDmode:
              if (!register_operand (operands[0], E_TDmode)
                  || !const0_operand (operands[1], E_TDmode)
                  || !register_operand (operands[2], E_TDmode)
                  || !(
#line 1558 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 1779; /* *cmptd_ccz_0 */

            case E_DDmode:
              if (!register_operand (operands[0], E_DDmode)
                  || !const0_operand (operands[1], E_DDmode)
                  || !register_operand (operands[2], E_DDmode)
                  || !(
#line 1558 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 1780; /* *cmpdd_ccz_0 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pattern38 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_TImode:
              if (pattern219 (x3, 
E_TImode) != 0
                  || !
#line 6615 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2238; /* *subti3 */

            case E_DImode:
              if (pattern219 (x3, 
E_DImode) != 0)
                return -1;
              if (
#line 6706 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
                return 2243; /* *subdi3_31z */
              if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2245; /* *subdi3 */

            case E_SImode:
              if (pattern219 (x3, 
E_SImode) != 0)
                return -1;
              return 2246; /* *subsi3 */

            case E_TFmode:
              if (pattern219 (x3, 
E_TFmode) != 0
                  || !(
#line 6931 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2262; /* subtf3_fpr */

            case E_FPRX2mode:
              if (pattern219 (x3, 
E_FPRX2mode) != 0
                  || !(
#line 6931 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2263; /* subfprx23 */

            case E_DFmode:
              if (pattern219 (x3, 
E_DFmode) != 0
                  || !
#line 6931 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2264; /* subdf3 */

            case E_SFmode:
              if (pattern219 (x3, 
E_SFmode) != 0
                  || !
#line 6931 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2265; /* subsf3 */

            case E_TDmode:
              if (pattern219 (x3, 
E_TDmode) != 0
                  || !(
#line 6931 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2266; /* subtd3 */

            case E_DDmode:
              if (pattern219 (x3, 
E_DDmode) != 0
                  || !(
#line 6931 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                return -1;
              return 2267; /* subdd3 */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern248 (x3, 
E_DImode) != 0)
                return -1;
              if (general_operand (operands[2], E_SImode)
                  && 
#line 6654 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return 2239; /* *subdi3_sign */
              if (!memory_operand (operands[2], E_HImode)
                  || !
#line 6880 "../../gcc/config/s390/s390.md"
(TARGET_Z14))
                return -1;
              return 2259; /* *subdi3_sign */

            case E_SImode:
              if (pattern248 (x3, 
E_SImode) != 0
                  || !memory_operand (operands[2], E_HImode))
                return -1;
              return 2244; /* *subsi3_sign */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          if (!general_operand (operands[2], E_SImode)
              || !
#line 6694 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2242; /* *subdi3_zero */

        default:
          return -1;
        }

    case MINUS:
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern249 (x3, 
E_DImode) != 0
              || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2294; /* *subdi3_slb */

        case E_SImode:
          if (pattern249 (x3, 
E_SImode) != 0)
            return -1;
          return 2295; /* *subsi3_slb */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_106 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pattern38 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      if (pattern178 (x3) != 0
          || !
#line 9099 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      return 2417; /* *negdi2_sign */

    case REG:
    case SUBREG:
      switch (pattern179 (x3))
        {
        case 0:
          if (
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2422; /* *negdi2 */
          if (!
#line 9141 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2424; /* *negdi2_31 */

        case 1:
          return 2423; /* *negsi2 */

        case 2:
          if (!(
#line 9264 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          return 2439; /* *negtf2 */

        case 3:
          if (!(
#line 9264 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          return 2440; /* *negfprx22 */

        case 4:
          if (!
#line 9264 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2441; /* *negdf2 */

        case 5:
          if (!
#line 9264 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2442; /* *negsf2 */

        default:
          return -1;
        }

    case ABS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x6 = XEXP (x5, 0);
          operands[1] = x6;
          if (!register_operand (operands[1], E_SImode)
              || !
#line 9447 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          return 2470; /* *negabsdi2_sign */

        case REG:
        case SUBREG:
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern228 (x3, 
E_DImode) != 0
                  || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                return -1;
              return 2475; /* *negabsdi2 */

            case E_SImode:
              if (pattern228 (x3, 
E_SImode) != 0)
                return -1;
              return 2476; /* *negabssi2 */

            case E_TFmode:
              if (pattern228 (x3, 
E_TFmode) != 0
                  || !(
#line 9527 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                return -1;
              return 2491; /* *negabstf2 */

            case E_FPRX2mode:
              if (pattern228 (x3, 
E_FPRX2mode) != 0
                  || !(
#line 9527 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 758 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                return -1;
              return 2492; /* *negabsfprx22 */

            case E_DFmode:
              if (pattern228 (x3, 
E_DFmode) != 0
                  || !
#line 9527 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2493; /* *negabsdf2 */

            case E_SFmode:
              if (pattern228 (x3, 
E_SFmode) != 0
                  || !
#line 9527 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2494; /* *negabssf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VOIDmode))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 1)
    return -1;
  switch (GET_MODE (x3))
    {
    case E_DImode:
      if (!(
#line 11045 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
        return -1;
      return 2578; /* *basr_r_via_thunk */

    case E_SImode:
      if (!(
#line 11045 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)
   && GET_MODE (operands[3]) == Pmode) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
        return -1;
      return 2579; /* *basr_r_via_thunk */

    default:
      return -1;
    }
}

 int
recog_112 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_111 (x1, insn, pnum_clobbers);

    case CLOBBER:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_BLKmode)
        return -1;
      switch (pattern126 (x1))
        {
        case 0:
          if (!
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1884; /* *movstr */

        case 1:
          if (!
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 1885; /* *movstr */

        case 2:
          if (!(
#line 3954 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1902; /* *setmem_long */

        case 3:
          if (!(
#line 3954 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1903; /* *setmem_long */

        case 4:
          if (!
#line 3982 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 1906; /* *setmem_long_31z */

        case 5:
          if (!(
#line 3967 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1904; /* *setmem_long_and */

        case 6:
          if (!(
#line 3967 "../../gcc/config/s390/s390.md"
((TARGET_64BIT || !TARGET_ZARCH)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          *pnum_clobbers = 1;
          return 1905; /* *setmem_long_and */

        case 7:
          if (!
#line 3994 "../../gcc/config/s390/s390.md"
((!TARGET_64BIT && TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1907; /* *setmem_long_and_31z */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern14 (x1) != 0)
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != LABEL_REF)
        return -1;
      x7 = XVECEXP (x2, 0, 0);
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      x3 = XVECEXP (x1, 0, 1);
      x9 = XEXP (x3, 1);
      operands[0] = x9;
      x10 = XEXP (x6, 0);
      operands[1] = x10;
      x11 = XVECEXP (x2, 0, 1);
      switch (GET_CODE (x11))
        {
        case CONST_INT:
          if (XWINT (x11, 0) != 0LL)
            return -1;
          if (larl_operand (operands[2], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10612 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2556; /* casesi_jump_via_inlinethunkdi_z10 */
          if (!larl_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10612 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2557; /* casesi_jump_via_inlinethunksi_z10 */

        case REG:
        case SUBREG:
          operands[3] = x11;
          if (register_operand (operands[3], E_DImode)
              && larl_operand (operands[2], E_DImode)
              && register_operand (operands[0], E_DImode)
              && (
#line 10629 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return 2558; /* casesi_jump_via_inlinethunkdi */
          if (!register_operand (operands[3], E_SImode)
              || !larl_operand (operands[2], E_SImode)
              || !register_operand (operands[0], E_SImode)
              || !(
#line 10629 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_INLINE_THUNK
   && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2559; /* casesi_jump_via_inlinethunksi */

        default:
          return -1;
        }

    case CALL:
      x12 = XEXP (x2, 0);
      if (GET_CODE (x12) != MEM
          || GET_MODE (x12) != E_QImode
          || pattern15 (x1, 
CLOBBER) != 0)
        return -1;
      x13 = XEXP (x12, 0);
      operands[0] = x13;
      x14 = XEXP (x2, 1);
      operands[1] = x14;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XEXP (x3, 0);
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !register_operand (operands[2], E_DImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_DImode
              || !(
#line 10934 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          return 2572; /* *basr_via_thunkdi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !register_operand (operands[2], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_SImode
              || !(
#line 10934 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_CALL
   && !TARGET_CPU_Z10
   && !SIBLING_CALL_P (insn)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2573; /* *basr_via_thunksi */

        default:
          return -1;
        }

    case RETURN:
      if (pattern15 (x1, 
USE) != 0)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_DImode
              || !(
#line 11872 "../../gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          return 2621; /* returndi_prez10 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          x6 = XEXP (x5, 0);
          if (GET_MODE (x6) != E_SImode
              || !(
#line 11872 "../../gcc/config/s390/s390.md"
(!TARGET_CPU_Z10 && TARGET_INDIRECT_BRANCH_NOBP_RET_OPTION) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2622; /* returnsi_prez10 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_119 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          res = recog_109 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 3:
          res = recog_112 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 4:
          res = recog_113 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 6:
          res = recog_114 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 5:
          res = recog_115 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 34:
          res = recog_116 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case 18:
          if (pattern6 (x1, 
19, 
E_DFmode, 
18, 
17) == 0
              && pattern298 (x1, 
23, 
E_DFmode, 
22, 
21, 
20) == 0
              && pattern299 (x1, 
27, 
E_DFmode, 
26, 
25, 
24) == 0
              && pattern300 (x1, 
E_DFmode, 
31, 
30, 
29, 
28) == 0)
            {
              x2 = XVECEXP (x1, 0, 0);
              x3 = XEXP (x2, 1);
              x4 = XVECEXP (x3, 0, 0);
              operands[0] = x4;
              if (const_int_operand (operands[0], E_VOIDmode))
                {
                  x5 = XVECEXP (x1, 0, 1);
                  x6 = XEXP (x5, 0);
                  operands[1] = x6;
                  if (memory_operand (operands[1], E_BLKmode))
                    {
                      x7 = XEXP (x5, 1);
                      x8 = XVECEXP (x7, 0, 0);
                      if (rtx_equal_p (x8, operands[0])
                          && 
#line 12408 "../../gcc/config/s390/s390.md"
(TARGET_HTM && INTVAL (operands[0]) >= 0 && INTVAL (operands[0]) <= 0xffff))
                        return 2649; /* tbegin_1 */
                    }
                }
            }
          break;

        default:
          break;
        }
      if (XVECLEN (x1, 0) >= 1)
        {
          operands[0] = x1;
          res = recog_117 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      switch (XVECLEN (x1, 0))
        {
        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_CODE (x7) != UNSPEC_VOLATILE)
            return -1;
          x9 = XEXP (x2, 0);
          operands[0] = x9;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          x6 = XEXP (x5, 0);
          if (!rtx_equal_p (x6, operands[1]))
            return -1;
          switch (XVECLEN (x7, 0))
            {
            case 3:
              if (XINT (x7, 1) != 9)
                return -1;
              x10 = XVECEXP (x1, 0, 2);
              if (pattern180 (x10) != 0)
                return -1;
              x11 = XVECEXP (x7, 0, 1);
              operands[2] = x11;
              x12 = XVECEXP (x7, 0, 2);
              operands[3] = x12;
              x8 = XVECEXP (x7, 0, 0);
              if (!rtx_equal_p (x8, operands[1]))
                return -1;
              x13 = XEXP (x10, 1);
              x14 = XEXP (x13, 0);
              if (!rtx_equal_p (x14, operands[1]))
                return -1;
              x15 = XEXP (x13, 1);
              if (!rtx_equal_p (x15, operands[2]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern279 (x7, 
E_DImode) != 0)
                    return -1;
                  if (
#line 11348 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && s390_match_ccmode (insn, CCZ1mode)))
                    return 2592; /* *atomic_compare_and_swapdi_1 */
                  if (!
#line 11366 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH
   && s390_match_ccmode (insn, CCZ1mode)))
                    return -1;
                  return 2593; /* *atomic_compare_and_swapdi_2 */

                case E_SImode:
                  if (pattern279 (x7, 
E_SImode) != 0
                      || !
#line 11387 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCZ1mode)))
                    return -1;
                  return 2594; /* *atomic_compare_and_swapsi_3 */

                default:
                  return -1;
                }

            case 1:
              if (XINT (x7, 1) != 10)
                return -1;
              x10 = XVECEXP (x1, 0, 2);
              if (GET_CODE (x10) != CLOBBER)
                return -1;
              x16 = XEXP (x10, 0);
              if (GET_CODE (x16) != REG
                  || REGNO (x16) != 33
                  || GET_MODE (x16) != E_CCmode)
                return -1;
              x8 = XVECEXP (x7, 0, 0);
              switch (GET_CODE (x8))
                {
                case AND:
                  switch (pattern218 (x7))
                    {
                    case 0:
                      if (!(
#line 11427 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2595; /* atomic_fetch_anddi_iaf */

                    case 1:
                      if (!
#line 11427 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2599; /* atomic_fetch_andsi_iaf */

                    default:
                      return -1;
                    }

                case IOR:
                  switch (pattern218 (x7))
                    {
                    case 0:
                      if (!(
#line 11427 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2596; /* atomic_fetch_ordi_iaf */

                    case 1:
                      if (!
#line 11427 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2600; /* atomic_fetch_orsi_iaf */

                    default:
                      return -1;
                    }

                case XOR:
                  switch (pattern218 (x7))
                    {
                    case 0:
                      if (!(
#line 11427 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2597; /* atomic_fetch_xordi_iaf */

                    case 1:
                      if (!
#line 11427 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2601; /* atomic_fetch_xorsi_iaf */

                    default:
                      return -1;
                    }

                case PLUS:
                  switch (pattern218 (x7))
                    {
                    case 0:
                      if (!(
#line 11427 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                        return -1;
                      return 2598; /* atomic_fetch_adddi_iaf */

                    case 1:
                      if (!
#line 11427 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
                        return -1;
                      return 2602; /* atomic_fetch_addsi_iaf */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return -1;
          if (pnum_clobbers != NULL)
            {
              res = recog_118 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x9 = XEXP (x2, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 15
              || GET_MODE (x9) != E_DImode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != CLOBBER)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != MEM
              || GET_MODE (x6) != E_BLKmode)
            return -1;
          x17 = XEXP (x6, 0);
          if (GET_CODE (x17) != SCRATCH)
            return -1;
          x3 = XEXP (x2, 1);
          operands[0] = x3;
          if (!register_operand (operands[0], E_DImode)
              || !
#line 11999 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 2629; /* stack_restore_from_fpr */

        default:
          return -1;
        }

    case TRAP_IF:
      x18 = XEXP (x1, 1);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x19 = XEXP (x1, 0);
      switch (GET_CODE (x19))
        {
        case CONST_INT:
          if (XWINT (x19, 0) != 1LL)
            return -1;
          return 2525; /* trap */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case LTGT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNEQ:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[0] = x19;
          if (s390_comparison (operands[0], E_VOIDmode))
            {
              x20 = XEXP (x19, 1);
              if (x20 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x21 = XEXP (x19, 0);
                  operands[1] = x21;
                  if (cc_reg_operand (operands[1], E_VOIDmode))
                    return 2526; /* condtrap */
                }
            }
          x21 = XEXP (x19, 0);
          operands[1] = x21;
          x20 = XEXP (x19, 1);
          operands[2] = x20;
          if (s390_signed_integer_comparison (operands[0], E_VOIDmode))
            {
              switch (GET_MODE (operands[1]))
                {
                case E_DImode:
                  if (register_operand (operands[1], E_DImode)
                      && nonmemory_operand (operands[2], E_DImode)
                      && (
#line 9967 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 2527; /* *cmp_and_trap_signed_intdi */
                  break;

                case E_SImode:
                  if (register_operand (operands[1], E_SImode)
                      && nonmemory_operand (operands[2], E_SImode)
                      && 
#line 9967 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                    return 2528; /* *cmp_and_trap_signed_intsi */
                  break;

                default:
                  break;
                }
            }
          if (!s390_unsigned_integer_comparison (operands[0], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_DImode:
              if (!register_operand (operands[1], E_DImode)
                  || !general_operand (operands[2], E_DImode)
                  || !(
#line 9981 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2529; /* *cmp_and_trap_unsigned_intdi */

            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !general_operand (operands[2], E_SImode)
                  || !
#line 9981 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 2530; /* *cmp_and_trap_unsigned_intsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          switch (XINT (x1, 1))
            {
            case 0:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2560; /* blockage */

            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2604; /* nop_lr0 */

            case 12:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2605; /* nop_lr1 */

            case 13:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2606; /* nop_2_byte */

            case 14:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2607; /* nop_4_byte */

            case 15:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2608; /* nop_6_byte */

            case 6:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!consttable_operand (operands[0], E_VOIDmode))
                return -1;
              return 2609; /* *pool_entry */

            case 5:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 2610; /* pool_align */

            case 4:
              x2 = XVECEXP (x1, 0, 0);
              if (GET_CODE (x2) != CONST_INT)
                return -1;
              switch (XWINT (x2, 0))
                {
                case 1LL:
                  return 2611; /* pool_section_start */

                case 0LL:
                  return 2612; /* pool_section_end */

                default:
                  return -1;
                }

            case 3:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!const_int_operand (operands[0], E_VOIDmode))
                return -1;
              return 2616; /* pool */

            case 20:
              x2 = XVECEXP (x1, 0, 0);
              switch (GET_CODE (x2))
                {
                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_POLY_INT:
                case CONST_FIXED:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                case REG:
                case SUBREG:
                case LABEL_REF:
                case SYMBOL_REF:
                case HIGH:
                  operands[0] = x2;
                  if (!nonmemory_operand (operands[0], E_SImode)
                      || !
#line 12477 "../../gcc/config/s390/s390.md"
(TARGET_HTM))
                    return -1;
                  return 2653; /* *tabort_1 */

                case PLUS:
                  if (GET_MODE (x2) != E_SImode)
                    return -1;
                  x9 = XEXP (x2, 0);
                  operands[0] = x9;
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  x3 = XEXP (x2, 1);
                  operands[1] = x3;
                  if (!const_int_operand (operands[1], E_SImode)
                      || !
#line 12485 "../../gcc/config/s390/s390.md"
(TARGET_HTM && CONST_OK_FOR_CONSTRAINT_P (INTVAL (operands[1]), 'J', "J")))
                    return -1;
                  return 2654; /* *tabort_1_plus */

                default:
                  return -1;
                }

            case 24:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 12533 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2658; /* sfpc */

            case 27:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 2665; /* osc_break */

            default:
              return -1;
            }

        case 3:
          if (XINT (x1, 1) != 23)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || !
#line 12523 "../../gcc/config/s390/s390.md"
((TARGET_ZEC12 || TARGET_HTM) && INTVAL (operands[2]) < 16))
            return -1;
          return 2657; /* *ppa */

        default:
          return -1;
        }

    case CALL:
      x19 = XEXP (x1, 0);
      if (GET_CODE (x19) != MEM
          || GET_MODE (x19) != E_QImode)
        return -1;
      x18 = XEXP (x1, 1);
      if (!const_int_operand (x18, E_VOIDmode))
        return -1;
      x21 = XEXP (x19, 0);
      switch (GET_CODE (x21))
        {
        case REG:
          if (REGNO (x21) != 1)
            return -1;
          operands[0] = x18;
          if (!
#line 10741 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)
   && GET_MODE (XEXP (XEXP (PATTERN (insn), 0), 0)) == Pmode))
            return -1;
          return 2561; /* *sibcall_br */

        case CONST:
        case SYMBOL_REF:
          operands[0] = x21;
          if (!bras_sym_operand (operands[0], E_VOIDmode))
            return -1;
          operands[1] = x18;
          if (
#line 10770 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn) && TARGET_SMALL_EXEC))
            return 2562; /* *sibcall_brc */
          if (!
#line 10778 "../../gcc/config/s390/s390.md"
(SIBLING_CALL_P (insn)))
            return -1;
          return 2563; /* *sibcall_brcl */

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x1, 0) != 0LL)
        return -1;
      return 2603; /* nop */

    case RETURN:
      if (!
#line 11797 "../../gcc/config/s390/s390.md"
(s390_can_use_return_insn ()))
        return -1;
      return 2617; /* return */

    case SIMPLE_RETURN:
      if (!
#line 11797 "../../gcc/config/s390/s390.md"
(s390_can_use_simple_return_insn ()))
        return -1;
      return 2618; /* simple_return */

    case PREFETCH:
      x19 = XEXP (x1, 0);
      operands[0] = x19;
      if (!address_operand (operands[0], E_VOIDmode))
        return -1;
      x18 = XEXP (x1, 1);
      operands[1] = x18;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x22 = XEXP (x1, 2);
      operands[2] = x22;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 12011 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return -1;
      return 2630; /* prefetch */

    default:
      return -1;
    }
}
